/*
 * arch/arm/mach-tcc93xx/board-tcc9300.h
 *
 * Copyright (C) 2010 Telechips, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __ARCH_ARM_MACH_TCC93XX_BOARD_TCC9300_H
#define __ARCH_ARM_MACH_TCC93XX_BOARD_TCC9300_H

#define TCC_PMEM_BASE		TCC_MEM_BASE
#define TCC_PMEM_SIZE		(16 * SZ_1M)

#define TCC_RAM_CONSOLE_BASE	(TCC_MEM_BASE + TCC_PMEM_SIZE)
#define TCC_RAM_CONSOLE_SIZE	(128 * SZ_1K)

#define TCC_MEM_SIZE		(TCC_PMEM_SIZE + TCC_RAM_CONSOLE_SIZE)

#if defined(CONFIG_TCC_MEM_128MB)
#define TCC_SDRAM_SIZE		SZ_128M
#elif defined(CONFIG_TCC_MEM_256MB)
#define TCC_SDRAM_SIZE		SZ_256M
#elif defined(CONFIG_TCC_MEM_512MB)
#define TCC_SDRAM_SIZE		SZ_512M
#endif

#define TCC_MEM_BASE		(PHYS_OFFSET + TCC_SDRAM_SIZE - TCC_MEM_SIZE)

#endif
