/****************************************************************************
*   FileName    : TCC93x_Physical.h
*   Description :
****************************************************************************
*
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*
****************************************************************************/

/****************************************************************************

  Revision History

 ****************************************************************************/

/************************************************************************
*   TCC89x Internal Register Definition File
************************************************************************/
#ifndef __TCC93x_H__
#define __TCC93x_H__

/************************************************************************
*   Bit Field Definition
************************************************************************/
#define Hw37                                    (1LL << 37)
#define Hw36                                    (1LL << 36)
#define Hw35                                    (1LL << 35)
#define Hw34                                    (1LL << 34)
#define Hw33                                    (1LL << 33)
#define Hw32                                    (1LL << 32)
#define Hw31                                    0x80000000
#define Hw30                                    0x40000000
#define Hw29                                    0x20000000
#define Hw28                                    0x10000000
#define Hw27                                    0x08000000
#define Hw26                                    0x04000000
#define Hw25                                    0x02000000
#define Hw24                                    0x01000000
#define Hw23                                    0x00800000
#define Hw22                                    0x00400000
#define Hw21                                    0x00200000
#define Hw20                                    0x00100000
#define Hw19                                    0x00080000
#define Hw18                                    0x00040000
#define Hw17                                    0x00020000
#define Hw16                                    0x00010000
#define Hw15                                    0x00008000
#define Hw14                                    0x00004000
#define Hw13                                    0x00002000
#define Hw12                                    0x00001000
#define Hw11                                    0x00000800
#define Hw10                                    0x00000400
#define Hw9                                     0x00000200
#define Hw8                                     0x00000100
#define Hw7                                     0x00000080
#define Hw6                                     0x00000040
#define Hw5                                     0x00000020
#define Hw4                                     0x00000010
#define Hw3                                     0x00000008
#define Hw2                                     0x00000004
#define Hw1                                     0x00000002
#define Hw0                                     0x00000001
#define HwZERO                                  0x00000000



/*******************************************************************************
*    TCC9300 DataSheet PART 2 SMU & PMU_V0.01 Dec.11 2008
********************************************************************************/
/************************************************************************
*   1. Clock Controller Register Define             (Base Addr = 0xB0500000) // R/W
************************************************************************/
#define HwCKC_BASE                                  *(volatile unsigned long*)0xB0500000
#define HwCLK_BASE                                  HwCKC_BASE

#define HwCKC										((PCKC)&HwCLK_BASE)

/************************************************************************
*   2. Timer, Counter Register Define              (Base Addr = 0xB0501000) // R/W
************************************************************************/
#define HwTMR_BASE                                  *(volatile unsigned long*)0xB0501000

/************************************************************************
*   3. Power Management Unit Register Define        (Base Addr = 0xB0503000) // R/W
************************************************************************/
#define HwPMU_BASE                                  *(volatile unsigned long*)0xB0503000

// Wake UP Control
#define	HwPMU_WKUP_GPIOE25			Hw31
#define	HwPMU_WKUP_GPIOE24			Hw30
#define	HwPMU_WKUP_GPIOE05			Hw29
#define	HwPMU_WKUP_GPIOE04			Hw28
#define	HwPMU_WKUP_GPIOB31			Hw27
#define	HwPMU_WKUP_GPIOB30			Hw26
#define	HwPMU_WKUP_GPIOA19			Hw25
#define	HwPMU_WKUP_GPIOA14			Hw24
#define	HwPMU_WKUP_GPIOA13			Hw23
#define	HwPMU_WKUP_GPIOA18			Hw22
#define	HwPMU_WKUP_GPIOA17			Hw21
#define	HwPMU_WKUP_GPIOA16			Hw20
#define	HwPMU_WKUP_GPIOA07			Hw19
#define	HwPMU_WKUP_GPIOA06			Hw18
#define	HwPMU_WKUP_GPIOA05			Hw17
#define	HwPMU_WKUP_GPIOA04			Hw16
#define	HwPMU_WKUP_GPIOA03			Hw15
#define	HwPMU_WKUP_GPIOA02			Hw14
#define	HwPMU_WKUP_TSC_UPDOWN		Hw13										// Touch Screen Up/Down Signal
#define	HwPMU_WKUP_TSC_STOP_WKU		Hw12										// Touch Screen Stop Wakeup Signal
#define	HwPMU_WKUP_GPIOD18			Hw11
#define	HwPMU_WKUP_TSC_WKU			Hw10										// Touch Screen Wake-Up Signal
#define	HwPMU_WKUP_GPIOF17			Hw9
#define	HwPMU_WKUP_GPIOF16			Hw8
#define	HwPMU_WKUP_GPIOF28			Hw7
#define	HwPMU_WKUP_GPIOF26			Hw6
#define	HwPMU_WKUP_GPIOF27			Hw5
#define	HwPMU_WKUP_GPIOC31			Hw4
#define	HwPMU_WKUP_GPIOC30			Hw3
#define	HwPMU_WKUP_GPIOC29			Hw2
#define	HwPMU_WKUP_GPIOC28			Hw1
#define	HwPMU_WKUP_RTCWKUP			Hw0											// RTC Wakeup Output Signal

/************************************************************************
*   4. SMU I2C Register Define                      (Base Addr = 0xB0505000) // R/W
************************************************************************/
#define HwSMUI2C_BASE                               *(volatile unsigned long*)0xB0505000
#define HwSMUI2C_CH1_BASE                               *(volatile unsigned long*)0xB0505040
#define HwSMU_I2CICLK_BASE                          *(volatile unsigned long*)0xB0505080

/************************************************************************
*   5. RealTime Clock Register Define               (Base Addr = 0xB0502000) // R/W
************************************************************************/
#define HwRTC_BASE                                  *(volatile unsigned long*)0xB0502000

/************************************************************************
*   6. SMU Config Register Define                   (Base Addr = 0xB0504000) // R/W
************************************************************************/
#define HwSMUCONFIG_BASE                            *(volatile unsigned long*)0xB0504000





/*******************************************************************************
*    TCC9300 DataSheet PART 3 GRAPHIC BUS
********************************************************************************/
/************************************************************************
*   x. Overlay Mixer  Register Define               (Base Addr = 0xB0700000) // R/W
************************************************************************/
//#define HwOVERLAYMIXER_BASE                       *(volatile unsigned long*)0xB0700000
// Refer to IOBUS


/************************************************************************
*   4. 2D/3D GPU Register Define                   (Base Addr = 0xB0700000) // R/W
************************************************************************/
#define HwGPU_BASE                                  *(volatile unsigned long*)0xB0700000

/************************************************************************
*   4-3. Pixel Processor Register Define            (Base Addr = 0xB0700000) // R/W
************************************************************************/
#define HwPIXELPROCESSOR_BASE                       *(volatile unsigned long*)0xB0700000
#define HwGPU_PXL_FRAMEREGISTERS_BASE               *(volatile unsigned long*)0xB0700000
#define HwGPU_PXL_WRITEBACKREGISTER_BASE            *(volatile unsigned long*)0xB0700100
#define HWGPU_PXL_MANAGEMENTREGISTER_BASE           *(volatile unsigned long*)0xB0701000

/************************************************************************
*   4-4. Geometry Processor Register Define         (Base Addr = 0xB0702000) // R/W
************************************************************************/
#define HwGEOMETRYPROCESSOR_BASE                    *(volatile unsigned long*)0xB0702000
#define HwGPU_GEO_CONTROLREGISTER_BASE              *(volatile unsigned long*)0xB0702000
#define HwGPU_GEO_PLBCONFIGREGISTER_BASE            *(volatile unsigned long*)0xB0702100
//#define HwGPU_GEO_PLBCONFIGREGISTER_BASE          *(volatile unsigned long*)0xB0700100
#define HwGPU_GEO_VERTEXSHADER_BASE                 *(volatile unsigned long*)0xB0700000

/*************************************************************************
*   4-5. MMU Register Define                        (Base Addr = 0xB0703000) // R/W
************************************************************************/
#define HwGPUMMUCONFIG_BASE                         *(volatile unsigned long*)0xB0703000

/************************************************************************
*   5-1. Graphic Bus Configuration Register Define  (Base Addr = 0xB0704000) // R/W
************************************************************************/
#define HwGRPBUSCONFIG_BASE                         *(volatile unsigned long*)0xB0704000
/************************************************************************
*   5-2. GRPBUS BWRAP Register Define               (Base Addr = 0xB0705000) // R/W
************************************************************************/
#define HwGRPBUSBWRAP_BASE                          *(volatile unsigned long*)0xB0705000






/*******************************************************************************
*    TCC9300 DataSheet PART 4 MEMORY BUS
********************************************************************************/
/************************************************************************
*   1. Multi-layer Bus Matrix Register Define      (Base Addr = 0xB0300000) // R/W
************************************************************************/
#define HwMULTILAYERBUSMATRIX_BASE                  *(volatile unsigned long*)0xB0300000
/*
0xB0303000      DDR I/F Configuration Registers
0xB0304400      DDR3 PHY Configuration Registers
0xB0305000      LPDDR/LPDDR2/DDR2 SDRAM Controller Registers
0xB0306000      Static Memory Controller Registers
0xB0307000      Internal Memory I/F Configuration Registers
0xB0308000      EDI (External Device Interface) Registers
0xB0309000      Reserved
0xB030A000      Reserved
0xB030B000      Memory Bus Configuration Registers
0xB030C000      DDR2/DDR3 SDRAM Controller Registers
0xC0000000      Hardware MMU Table.
*/
/************************************************************************
*   4-2. DDR SDRAM Controller Register Define       (Base Addr = 0xB0301000) // R/W
************************************************************************/
#define HwLPDDR_BASE                                *(volatile unsigned long*)0xB0301000
#define HwDDR2_BASE                                 *(volatile unsigned long*)0xB0302000
#define HwLPDDRCFG_BASE                             *(volatile unsigned long*)0xB0303000
#define HwDDR3_BASE                                 *(volatile unsigned long*)0xB030C000
#define HwDDRIFCFG_BASE                             *(volatile unsigned long*)0xB0303000
//#define HwDDRIFCFG_BASE                           *(volatile unsigned lohg*)0xB0304000
#define HwDDR3PHY_BASE                              *(volatile unsigned long*)0xB0304400
#define HwLPDDR2_BASE                               *(volatile unsigned long*)0xB0305000

/************************************************************************
*   5. Static Memory Controller Register Define     (Base Addr = 0xB0306000) // R/W
************************************************************************/
#define HwSMC_BASE                                  *(volatile unsigned long*)0xB0306000

/************************************************************************
*   6. External Device Interface Register Define    (Base Addr = 0xB0308000) // R/W
************************************************************************/
#define HwEDI_BASE                                  *(volatile unsigned long*)0xB0308000

/************************************************************************
*   8. Memory Bus Configuration Register Define     (Base Addr = 0xB030B000) // R/W
************************************************************************/
#define HwMEMBUSCFG_BASE                            *(volatile unsigned long*)0xB030B000

/************************************************************************
*   9. Internal Memory Bus Configuration Register Define  (Base Addr = 0xB0307000) // R/W
************************************************************************/
#define HwINTNLMEMBUSCFG_BASE                       *(volatile unsigned long*)0xB0307000
#define	HwVMT_BASE									*(volatile unsigned long*)0xC0000000
#define	HwREGION_BASE								*(volatile unsigned long*)0xB0307000

/*******************************************************************************
*    TCC9300 DataSheet PART 5 IO BUS
********************************************************************************/
/************************************************************************
*   4. SD/SDIO/MMC Register Define                  (Base Addr = 0xB0020000) // R/W
************************************************************************/
#define HwSDMMC_BASE                                *(volatile unsigned long*)0xB0020000
#define HwSDMMC0_BASE                               *(volatile unsigned long*)0xB0020000
#define HwSDMMC1_BASE                               *(volatile unsigned long*)0xB0020200
#define HwSDMMC2_BASE                               *(volatile unsigned long*)0xB0020400
#define HwSDMMC3_BASE                               *(volatile unsigned long*)0xB0020600
#define HwSDMMC_CTRL_BASE							*(volatile unsigned long*)0xB0020800

/************************************************************************
*   5. External Host Interface Register Define      (Base Addr = 0xB0010000) // R/W
*************************************************************************/
// If HPCSN is 0
#define HwEHI_HPCSN0_BASE                           *(volatile unsigned long*)0xB0000000
// if HPCSN is 1
#define HwEHI_HPCSN1_BASE                           *(volatile unsigned long*)0xB0010000


/************************************************************************
*   6. DMA Controller Register Define              (Base Addr = 0xB0030000) // R/W
************************************************************************/
#define HwGDMA_BASE                                 *(volatile unsigned long*)0xB0030000

// IOBUS
#define HwGDMA0_BASE                                *(volatile unsigned long*)0xB0030000
#define HwGDMA0CH0_BASE                             *(volatile unsigned long*)0xB0030000
#define HwGDMA0CH1_BASE                             *(volatile unsigned long*)0xB0030030
#define HwGDMA0CH2_BASE                             *(volatile unsigned long*)0xB0030060
#define HwGDMA0CONFIG_BASE                          *(volatile unsigned long*)0xB0030090

#define HwGDMA1_BASE                                *(volatile unsigned long*)0xB0030100
#define HwGDMA1CH0_BASE                             *(volatile unsigned long*)0xB0030100
#define HwGDMA1CH1_BASE                             *(volatile unsigned long*)0xB0030130
#define HwGDMA1CH2_BASE                             *(volatile unsigned long*)0xB0030160
#define HwGDMA1CONFIG_BASE                          *(volatile unsigned long*)0xB0030190

#define HwGDMA2_BASE                                *(volatile unsigned long*)0xB0030200
#define HwGDMA2CH0_BASE                             *(volatile unsigned long*)0xB0030200
#define HwGDMA2CH1_BASE                             *(volatile unsigned long*)0xB0030230
#define HwGDMA2CH2_BASE                             *(volatile unsigned long*)0xB0030260
#define HwGDMA2CONFIG_BASE                          *(volatile unsigned long*)0xB0030290

// HSIOBUS
#define HwGDMA3_BASE                                *(volatile unsigned long*)0xB0830000
#define HwGDMA3CH0_BASE                             *(volatile unsigned long*)0xB0830000
#define HwGDMA3CH1_BASE                             *(volatile unsigned long*)0xB0830330
#define HwGDMA3CH2_BASE                             *(volatile unsigned long*)0xB0830360
#define HwGDMA3CONFIG_BASE                          *(volatile unsigned long*)0xB0830390


/************************************************************************
*   7. GPIO Controller Register Define             (Base Addr = 0xB010A000) // R/W
************************************************************************/
#define HwGPIO_BASE                                 *(volatile unsigned long*)0xB010A000
#define HwGPIOA_BASE                                *(volatile unsigned long*)0xB010A000
#define HwGPIOB_BASE                                *(volatile unsigned long*)0xB010A040
#define HwGPIOC_BASE                                *(volatile unsigned long*)0xB010A080
#define HwGPIOD_BASE                                *(volatile unsigned long*)0xB010A0C0
#define HwGPIOE_BASE                                *(volatile unsigned long*)0xB010A100
#define HwGPIOF_BASE                                *(volatile unsigned long*)0xB010A140
#define HwGPIOG_BASE                                *(volatile unsigned long*)0xB010A180
#define HwEINTSEL_BASE                              *(volatile unsigned long*)0xB010A204
#define HwECID_BASE                                 *(volatile unsigned long*)0xB010A190
#define HwSYSMONEN_BASE                             *(volatile unsigned long*)0xB010A18C

#define HwGPIO										((PGPIO)&HwGPIO_BASE)
#define HwGPIOA										((PGPION)&HwGPIOA_BASE)
#define HwGPIOB										((PGPION)&HwGPIOB_BASE)
#define HwGPIOC										((PGPION)&HwGPIOC_BASE)
#define HwGPIOD										((PGPION)&HwGPIOD_BASE)
#define HwGPIOE										((PGPION)&HwGPIOE_BASE)
#define HwGPIOF										((PGPION)&HwGPIOF_BASE)
#define HwGPIOG										((PGPION)&HwGPIOG_BASE)

#define HwEINTSEL									((PGPIOINT)&HwEINTSEL_BASE)

#define	HwPORTCFG_GPFN0(X)			((X)<<0)	// 0~3
#define HwPORTCFG_GPFN0_MASK		(0xF)		// HwPORTCFG_GPFN0(15)
#define	HwPORTCFG_GPFN1(X)			((X)<<4)	// 4~7
#define HwPORTCFG_GPFN1_MASK		(0xF<<4)	// HwPORTCFG_GPFN1(15)
#define	HwPORTCFG_GPFN2(X)			((X)<<8)	// 8~11
#define HwPORTCFG_GPFN2_MASK		(0xF<<8)	// HwPORTCFG_GPFN2(15)
#define	HwPORTCFG_GPFN3(X)			((X)<<12)	// 12~15
#define HwPORTCFG_GPFN3_MASK		(0xF<<12)	// HwPORTCFG_GPFN3(15)
#define	HwPORTCFG_GPFN4(X)			((X)<<16)	// 16~19
#define HwPORTCFG_GPFN4_MASK		(0xF<<16)	// HwPORTCFG_GPFN4(15)
#define	HwPORTCFG_GPFN5(X)			((X)<<20)	// 20~23
#define HwPORTCFG_GPFN5_MASK		(0xF<<20)	// HwPORTCFG_GPFN5(15)
#define	HwPORTCFG_GPFN6(X)			((X)<<24)	// 24~27
#define HwPORTCFG_GPFN6_MASK		(0xF<<24)	// HwPORTCFG_GPFN6(15)
#define	HwPORTCFG_GPFN7(X)			((X)<<28)	// 28~31
#define HwPORTCFG_GPFN7_MASK		(0xF<<28)	// HwPORTCFG_GPFN7(15)

/************************************************************************
*   8. GPSB Controller Register Define              (Base Addr = 0xB0107000) // R/W
************************************************************************/
#define HwGPSBCH0_BASE              *(volatile unsigned long*)0xB0107000
#define HwGPSBCH1_BASE              *(volatile unsigned long*)0xB0107100
#define HwGPSBCH2_BASE              *(volatile unsigned long*)0xB0107200
#define HwGPSBCH3_BASE              *(volatile unsigned long*)0xB0107300
#define HwGPSBCH4_BASE              *(volatile unsigned long*)0xB0107400
#define HwGPSBCH5_BASE              *(volatile unsigned long*)0xB0107500
#define HwGPSBPORTCFG_BASE          *(volatile unsigned long*)0xB0107800
#define HwGPSBPIDTABLE_BASE         *(volatile unsigned long*)0xB0107F00

#define	HwGPSB_BASE(X)				*(volatile unsigned long *)(0xB0107000+(X)*0x100)
#define	HwGPSB_MAX_CH				4
// Status
#define	HwGPSB_STAT_WOR				Hw8											// Write FIFO over-run error flag
#define	HwGPSB_STAT_RUR				Hw7											// Read FIFO under-run error flag
#define	HwGPSB_STAT_WUR				Hw6											// Write FIFO under-run error flag
#define	HwGPSB_STAT_ROR				Hw5											// Read FIFO over-run error flag
#define	HwGPSB_STAT_RF				Hw4											// Read FIFO full flag
#define	HwGPSB_STAT_WE				Hw3											// Write FIFO empty flag
#define	HwGPSB_STAT_RNE				Hw2											// Read FIFO not empty flag
#define	HwGPSB_STAT_WTH				Hw1											// Wrtie FIFO valid entry count is under threshold
#define	HwGPSB_STAT_RTH				Hw0											// Read FIFO valid entry increased over threshold

#define	HwGPSB_PIDT(X)				*(volatile unsigned long *)(0xB0107F00+(X)*4)	// R/W, PID Table Register
#define	HwGPSB_PIDT_CH2				Hw31											// Channel 2 enable
#define	HwGPSB_PIDT_CH1				Hw30											// Channel 1 enable
#define	HwGPSB_PIDT_CH0				Hw29											// Channel 0 enable

#define	HwGPSB_DMAICR_ISD			Hw29										// IRQ Status for "Done Interrupt"
#define	HwGPSB_DMAICR_ISP			Hw28										// IRQ Status for "Packet Interrupt"
#define	HwGPSB_DMAICR_IRQS_TRANS	Hw20										// IRQ is generated when transmit is done.
#define	HwGPSB_DMAICR_IRQS_RCV		HwZERO										// IRQ is generated when receiving is done.
#define	HwGPSB_DMAICR_IED_EN		Hw17										// Enable "Done Interrupt"
#define	HwGPSB_DMAICR_IEP_EN		Hw16										// Enable "Packet Interrupt"
#define	HwGPSB_DMAICR_IRQPCNT_MASK	(Hw13-1)

// DMA Control
#define	HwGPSB_DMACTRL_DTE			Hw31										// Transmit DMA request enable
#define	HwGPSB_DMACTRL_DRE			Hw30										// Receive DMA request enable
#define	HwGPSB_DMACTRL_CT			Hw29										// Continuous mode enable
#define	HwGPSB_DMACTRL_END			Hw28										// Byte endian mode register
#define	HwGPSB_DMACTRL_MP			Hw19										// PID match mode register
#define	HwGPSB_DMACTRL_MS			Hw18										// Sync byte match control register
#define	HwGPSB_DMACTRL_TXAM(X)		((X)*Hw16)
#define	HwGPSB_DMACTRL_TXAM_MULTI	HwGPSB_DMACTRL_TXAM(0)						// TX address is rolling within full packet range
#define	HwGPSB_DMACTRL_TXAM_FIXED	HwGPSB_DMACTRL_TXAM(1)						// TX address is fixed to TXBASE
#define	HwGPSB_DMACTRL_TXAM_SINGLE	HwGPSB_DMACTRL_TXAM(2)						// TX address is rolling within 1 packet range
#define	HwGPSB_DMACTRL_TXAM_MASK	HwGPSB_DMACTRL_TXAM(3)
#define	HwGPSB_DMACTRL_RXAM(X)		((X)*Hw14)
#define	HwGPSB_DMACTRL_RXAM_MULTI	HwGPSB_DMACTRL_RXAM(0)						// RX address is rolling within full packet range
#define	HwGPSB_DMACTRL_RXAM_FIXED	HwGPSB_DMACTRL_RXAM(1)						// RX address is fixed to RXBASE
#define	HwGPSB_DMACTRL_RXAM_SINGLE	HwGPSB_DMACTRL_RXAM(2)						// RX address is rolling within 1 packet range
#define	HwGPSB_DMACTRL_RXAM_MASK	HwGPSB_DMACTRL_RXAM(3)
#define	HwGPSB_DMACTRL_MD_NOR		HwZERO										// normal mode
#define	HwGPSB_DMACTRL_MD_MP2TS		Hw4											// MPEG2-TS mode
#define	HwGPSB_DMACTRL_PCLR			Hw2											// Clear TX/RX Packet Counter
#define	HwGPSB_DMACTRL_EN			Hw0											// DMA enable

// Interrupt Enable
#define	HwGPSB_INTEN_DW				Hw31										// DMA request enable for transmit FIFO
#define	HwGPSB_INTEN_DR				Hw30										// DMA request enable for receive FIFO
#define	HwGPSB_INTEN_SWD_BHW		Hw27										// Swap byte in half-word
#define	HwGPSB_INTEN_SWD_HWW		Hw26										// Swap half-word in word
#define	HwGPSB_INTEN_SRD_BHW		Hw25										// Swap byte in half-word
#define	HwGPSB_INTEN_SRD_HWW		Hw24										// Swap half-word in word
#define	HwGPSB_INTEN_CFGWTH(X)		((X)*Hw20)									// Write FIFO threshold for Interrupt or DMA Request
#define	HwGPSB_INTEN_CFGWTH_MASK	HwGPSB_INTEN_CFGWTH(7)
#define	HwGPSB_INTEN_CFGRTH(X)		((X)*Hw16)									// Read FIFO threshold for Interrupt or DMA Request
#define	HwGPSB_INTEN_CFGRTH_MASK	HwGPSB_INTEN_CFGRTH(7)
#define	HwGPSB_INTEN_RC				Hw15										// Clear status[8:0] at the end of read cycle
#define	HwGPSB_INTEN_WOR			Hw8											// Write FIFO over-run error interrupt enable
#define	HwGPSB_INTEN_RUR			Hw7											//Read FIFO under-run error flag interrupt enable
#define	HwGPSB_INTEN_WUR			Hw6											// Write FIFO under-run error flag interrupt enable
#define	HwGPSB_INTEN_ROR			Hw5											// Read FIFO over-run error flag interrupt enable
#define	HwGPSB_INTEN_RF				Hw4											// Read FIFO full flag interrupt enable
#define	HwGPSB_INTEN_WE				Hw3											// Write FIFO empty flag interrupt enable
#define	HwGPSB_INTEN_RNE			Hw2											// Read FIFO not empty flag interrupt enable
#define	HwGPSB_INTEN_WTH			Hw1											// Wrtie FIFO valid entry count is under threshold interrupt enable
#define	HwGPSB_INTEN_RTH			Hw0											// Read FIFO valid entry increased over threshold interrupt enable


// Mode
#define	HwGPSB_MODE_DIVLDV(X)		((X)*Hw24)
#define	HwGPSB_MODE_DIVLDV_MASK		HwGPSB_MODE_DIVLDV(255)
#define	HwGPSB_MODE_TRE				Hw23										// Master recovery time (TRE+1)*SCKO
#define	HwGPSB_MODE_THL				Hw22										// Master hold time (THL+1)*SCKO
#define	HwGPSB_MODE_TSU				Hw21										// Master setup time (TSU+1)*SCKO
#define	HwGPSB_MODE_PCS				Hw20										// Polarity control for CS(FRM) - Master Only
#define	HwGPSB_MODE_PCS_HIGH		Hw20
#define	HwGPSB_MODE_PCD				Hw19										// Polarity control for CMD(FRM)- Master Only
#define	HwGPSB_MODE_PCD_HIGH		Hw19
#define	HwGPSB_MODE_PWD				Hw18										// Polarity control for transmit data - Master Only
#define	HwGPSB_MODE_PWD_RISE		Hw18
#define	HwGPSB_MODE_PRD				Hw17										// Polarity control for receive data - Master Only
#define	HwGPSB_MODE_PRD_FALL		Hw17
#define	HwGPSB_MODE_PCK				Hw16										// Polarity control for serial clock
#define	HwGPSB_MODE_CRF				Hw15										// Clear receive FIFO counter
#define	HwGPSB_MODE_CWF				Hw14										// Clear transmit FIFO counter
#define	HwGPSB_MODE_BWS(X)			((X)*Hw8)									// Bit width Selection.(BWS+1. Valid = 7~31)
#define	HwGPSB_MODE_BWS_MASK		HwGPSB_MODE_BWS(31)
#define	HwGPSB_MODE_SD				Hw7											// Data shift direction control
#define	HwGPSB_MODE_LB				Hw6											// Data looop-back enable
#define	HwGPSB_MODE_CTF				Hw4											// Continuous transfer mode enable
#define	HwGPSB_MODE_EN				Hw3											// Operation enable
#define	HwGPSB_MODE_SLV				Hw2											// Slave mode configuration
#define	HwGPSB_MODE_MD_SPI			HwZERO										// SPI compatible
#define	HwGPSB_MODE_MD_SSP			Hw0											// SSP Compatible

/************************************************************************
*   9. 2D Graphic Controller Register Define        (Base Addr = 0xB0070000) // R/W
************************************************************************/
#define HwOVERLAYMIXER_BASE                         *(volatile unsigned long*)0xB0070000
#define HwOVERLAYMIXER								((POVERLAYMIXER)&HwOVERLAYMIXER_BASE)

#define	HwGE_FCH_SSB				(Hw24+Hw25+Hw26)							// Operation Mode
#define	HwGE_DCH_SSB				(Hw24+Hw25+Hw26)							// Operation Mode

// Front-End Channel 0 Control
#define	HwGE_FCHO_OPMODE			(Hw8+Hw9+Hw10)								// Operation Mode
#define	HwGE_FCHO_SDFRM				(Hw0+Hw1+Hw2+Hw3+Hw4)						// Source Data Format

// Front-End Channel 1 Control
#define	HwGE_FCH1_OPMODE			(Hw8+Hw9+Hw10)								// Operation Mode
#define	HwGE_FCH1_SDFRM				(Hw0+Hw1+Hw2+Hw3+Hw4)						// Source Data Format

// Front-End Channel 2 Control
#define	HwGE_FCH2_OPMODE			(Hw8+Hw9+Hw10)								// Operation Mode
#define	HwGE_FCH2_SDFRM				(Hw0+Hw1+Hw2+Hw3+Hw4)						// Source Data Format

// Source Control
#define Hw2D_SCTRL_S2_ARITHMODE 			(Hw27+Hw26+Hw25)
#define Hw2D_SCTRL_S1_ARITHMODE 			(Hw24+Hw23+Hw22)
#define Hw2D_SCTRL_S0_ARITHMODE 			(Hw21+Hw20+Hw19)
#define Hw2D_SCTRL_S2_Y2REN 				(Hw18)
#define Hw2D_SCTRL_S1_Y2REN 				(Hw17)
#define Hw2D_SCTRL_S0_Y2REN 				(Hw16)
#define Hw2D_SCTRL_S2_Y2RMODE 				(Hw14+Hw13)
#define Hw2D_SCTRL_S1_Y2RMODE 				(Hw12+Hw11)
#define Hw2D_SCTRL_S0_Y2RMODE 				(Hw10+Hw9)
#define Hw2D_SCTRL_S2_CHROMAEN				(Hw8)
#define Hw2D_SCTRL_S1_CHROMAEN				(Hw7)
#define Hw2D_SCTRL_S0_CHROMAEN				(Hw6)
#define Hw2D_SCTRL_S2_SEL					(Hw5+Hw4)
#define Hw2D_SCTRL_S1_SEL					(Hw3+Hw2)
#define Hw2D_SCTRL_S0_SEL					(Hw1+Hw0)

// Source Operator Pattern
#define	HwGE_OP_ALL					(HwGE_ALPHA + HwGE_PAT_RY + HwGE_PAT_GU + HwGE_PAT_BV)
#define	HwGE_ALPHA					(Hw24+Hw25+Hw26+Hw27+Hw28+Hw29+Hw30+Hw31)						// ALPHA VALUE
#define	HwGE_PAT_RY					(Hw16+Hw17+Hw18+Hw19+Hw20+Hw21+Hw22+Hw23)	// Pattern Value RED,   Y
#define	HwGE_PAT_GU					(Hw8+Hw9+Hw10+Hw11+Hw12+Hw13+Hw14+Hw15)		// Pattern Value GREEN, U
#define	HwGE_PAT_BV					(Hw0+Hw1+Hw2+Hw3+Hw4+Hw5+Hw6+Hw7)			// Pattern Value BULE,  V

// Source Operation Control
#define	HwGE_OP_CTRL_ASEL1			(Hw23+Hw24)
#define	HwGE_OP_CTRL_CSEL1			(Hw21+Hw22)									// Chroma-key Source Selection
#define	HwGE_OP_CTRL_OP1_MODE		(Hw16+Hw17+Hw18+Hw19+Hw20)					// Operation 1 Mode
#define	HwGE_OP_CTRL_ASEL0			(Hw7+Hw8)
#define	HwGE_OP_CTRL_CSEL0			(Hw5+Hw6)									// Chroma-key Source Selection
#define	HwGE_OP_CTRL_OP0_MODE		(Hw0+Hw1+Hw2+Hw3+Hw4)						// Operation 0 Mode

// Back -End Channel Control
#define	HwGE_BCH_DCTRL_MABC			Hw21
#define	HwGE_BCH_DCTRL_YSEL			Hw18										// YUV4:4:4 to YUVx:x:x Y Control
#define	HwGE_BCH_DCTRL_XSEL			(Hw16+Hw17)									// YUV4:4:4 to YUVx:x:x X Control
#define	HwGE_BCH_DCTRL_CEN			Hw15										// Destination Format Converter Control
#define	HwGE_BCH_DCTRL_CMODE		(Hw13+Hw14)									// RGBtoYUV Converter Type
#define	HwGE_BCH_DCTRL_DSUV			Hw11
#define	HwGE_BCH_DCTRL_OPMODE		(Hw8+Hw9+Hw10)								// Operation Mode COPY, MIRROR, ROTATE 
#define	HwGE_BCH_DCTRL_DOP			Hw6	
#define	HwGE_BCH_DCTRL_DEN			Hw5	
#define	HwGE_BCH_DCTRL_DDFRM		(Hw0+Hw1+Hw2+Hw3+Hw4)						// Destination Data Format

// Graphic Engine Control
#define	HwGE_GE_INT_EN				Hw16										// Graphic Engine Interrupt Enable
#define	HwGE_GE_CTRL_EN				(Hw0+Hw1+Hw2)								// Graphic Engine Enable

// Graphic Engine Interrupt Request
#define	HwGE_GE_IREQ_FLG			Hw16										// Graphic Engine Flag Bit
#define	HwGE_GE_IREQ_IRQ			Hw0				

/************************************************************************
*   10. Audio DMA Controller 0 Register Define      (Base Addr = 0xB0103000) // R/W
************************************************************************/
// Audio 0  (7.1 Ch)
#define HwADMA0_BASE                                 *(volatile unsigned long*)0xB0103000
#define HwDAI0_BASE                                  *(volatile unsigned long*)0xB0104000
#define HwCDIF0_BASE                                 *(volatile unsigned long*)0xB0104080
#define HwSPDIF0TX_BASE                              *(volatile unsigned long*)0xB010B000
#define HwSPDIF0RX_BASE                              *(volatile unsigned long*)0xB010B800


/************************************************************************
*   11. Audio DMA Controller 1 Register Define      (Base Addr = 0xB0105000) // R/W
************************************************************************/
// Audio 1  (Stereo)
#define HwADMA1_BASE                                *(volatile unsigned long*)0xB0105000
#define HwDAI1_BASE                                 *(volatile unsigned long*)0xB0106000
#define HwCDIF1_BASE                                *(volatile unsigned long*)0xB0106080
#define HwSPDIF1TX_BASE                             *(volatile unsigned long*)0xB010D000

/************************************************************************
*   12. NAND Flash Controller Register Define       (Base Addr = 0xB0050000) // R/W
************************************************************************/

//--------------------------------------------------------------------------------------
// NFC Cotrol Register
//--------------------------------------------------------------------------------------
#define HwNFC_BASE                                  *(volatile unsigned long*)0xB0050000

#define	HwNFC_CTRL_CS3SEL_1			Hw31							// Nand Flash nCS3 is High (Disabled)
#define	HwNFC_CTRL_CS3SEL_0			HwZERO							// Nand Flash nCS3 is Low (Enabled)
#define	HwNFC_CTRL_CS2SEL_1			Hw30							// Nand Flash nCS2 is High (Disabled)
#define	HwNFC_CTRL_CS2SEL_0			HwZERO							// Nand Flash nCS2 is Low (Enabled)
#define	HwNFC_CTRL_CS1SEL_1			Hw29							// Nand Flash nCS1 is High (Disabled)
#define	HwNFC_CTRL_CS1SEL_0			HwZERO							// Nand Flash nCS1 is Low (Enabled)
#define	HwNFC_CTRL_CS0SEL_1			Hw28							// Nand Flash nCS0 is High (Disabled)
#define	HwNFC_CTRL_CS0SEL_0			HwZERO							// Nand Flash nCS0 is Low (Enabled)
#define	HwNFC_CTRL_CFG_nCS3			HwNFC_CTRL_CS3SEL_1
#define	HwNFC_CTRL_CFG_nCS2			HwNFC_CTRL_CS2SEL_1
#define	HwNFC_CTRL_CFG_nCS1			HwNFC_CTRL_CS1SEL_1
#define	HwNFC_CTRL_CFG_nCS0			HwNFC_CTRL_CS0SEL_1
#define	HwNFC_CTRL_CFG_NOACT		(Hw31|Hw30|Hw29|Hw28)

#define HwNFC_STATUS_RDY_RDY		Hw31
#define	HwNFC_CTRL_FS_RDY			Hw30							// FIFO status is Ready to write and read in FIFO
#define	HwNFC_CTRL_FS_BUSY			~Hw30							// FIFO status is Busy to write and read in FIFO

#define	HwNFC_CTRL_RDY_RDY			Hw29							// External Nand Flash Controller is Ready
#define	HwNFC_CTRL_RDY_BUSY			~Hw29							// External Nand Flash Controller is Busy

#define	HwNFC_CTRL_RDNDLY(X)		((X)*Hw25)						// Nand Flash Read Data Delay 
#define	HwNFC_CTRL_RDNDLY_0			HwNFC_CTRL_RDNDLY(0)			// Nand Flash Read Data Delay (NONE)
#define	HwNFC_CTRL_RDNDLY_1			HwNFC_CTRL_RDNDLY(1)			// Nand Flash Read Data Delay (1 Clock)
#define	HwNFC_CTRL_RDNDLY_2			HwNFC_CTRL_RDNDLY(2)			// Nand Flash Read Data Delay (2 Clock)
#define	HwNFC_CTRL_RDNDLY_3			HwNFC_CTRL_RDNDLY(3)			// Nand Flash Read Data Delay (3 Clock)
#define	HwNFC_CTRL_RDNDLY_4			HwNFC_CTRL_RDNDLY(4)			// Nand Flash Read Data Delay (4 Clock)
#define	HwNFC_CTRL_RDNDLY_5			HwNFC_CTRL_RDNDLY(5)			// Nand Flash Read Data Delay (5 Clock)
#define	HwNFC_CTRL_RDNDLY_6			HwNFC_CTRL_RDNDLY(6)			// Nand Flash Read Data Delay (6 Clock)
#define	HwNFC_CTRL_RDNDLY_7			HwNFC_CTRL_RDNDLY(7)			// Nand Flash Read Data Delay (7 Clock)

#define	HwNFC_CTRL_ARFW_FLAG_EN		Hw24							// Nand Flash Automatically Ready Flag Wait Enanble 
#define	HwNFC_CTRL_ARFW_FLAG_DIS	~Hw24							// Nand Flash Automatically Ready Flag Wait Disable
#define	HwNFC_CTRL_DACK_EN			Hw20							// Nand Flash DMA Acknowledge Enable
#define	HwNFC_CTRL_DACK_DIS			~Hw20							// Nand Flash DMA Acknowledge Disable
#define	HwNFC_CTRL_DMODE_NDMA		Hw19							// Nand Flash DMA Mode Selection ( NDMA )
#define	HwNFC_CTRL_DMODE_GDMA		~Hw19							// Nand Flash DMA Mode Selection ( GDMA )

#define	HwNFC_CTRL_BMODE_BURST		Hw18							// Nand Flash Burst Operation Mode Selection For NDMA( Burst Mode[User Data + ECC] )
#define	HwNFC_CTRL_BMODE_NOR		~Hw18							// Nand Flash Burst Operation Mode Selection For NDMA( Normal Mode[User Data])
#define	HwNFC_CTRL_ECCON_EN			Hw17							// Nand Flash ECC Encoding/Decoding Enable
#define	HwNFC_CTRL_ECCON_DIS		~Hw17							// Nand Flash ECC Encoding/Decoding Disable
#define	HwNFC_CTRL_PRSEL_P			Hw16							// Nand Flash Program Mode Selection for Burst Transfer
#define	HwNFC_CTRL_PRSEL_R			~Hw16							// Nand Flash Read Mode Selection for Burst Transfer

#define	HwNFC_CTRL_DNUM				Hw14							// Nand Flash Multiplee Data Configuration Number 
#define	HwNFC_CTRL_MASK_EN			Hw10							// Address/Command Mask Enable

#define	HwNFC_CTRL_BW(X)			((X)*Hw8)
#define	HwNFC_CTRL_BW_8				HwNFC_CTRL_BW(0)				// 1Read/Write
#define	HwNFC_CTRL_BW_16			HwNFC_CTRL_BW(1)				// 2Read/Write
#define	HwNFC_CTRL_BW_32			HwNFC_CTRL_BW(2)				// 4Read/Write

#define	HwNFC_CTRL_BSIZE(X)			((X)*Hw6)
#define	HwNFC_CTRL_BSIZE_1			HwNFC_CTRL_BSIZE(0)				// 1Read/Write
#define	HwNFC_CTRL_BSIZE_2			HwNFC_CTRL_BSIZE(1)				// 2Read/Write
#define	HwNFC_CTRL_BSIZE_4			HwNFC_CTRL_BSIZE(2)				// 4Read/Write
#define	HwNFC_CTRL_BSIZE_8			HwNFC_CTRL_BSIZE(3)				// 8Read/Write

#define	HwNFC_CTRL_PSIZE(X)			((X)*Hw3)
#define	HwNFC_CTRL_PSIZE_256		HwNFC_CTRL_PSIZE(0)				// 1 Page = 256 Half-Word
#define	HwNFC_CTRL_PSIZE_512		HwNFC_CTRL_PSIZE(1)				// 1 Page = 512 Byte
#define	HwNFC_CTRL_PSIZE_1024		HwNFC_CTRL_PSIZE(2)				// 1 Page = 1024 Half-Word
#define	HwNFC_CTRL_PSIZE_2048		HwNFC_CTRL_PSIZE(3)				// 1 Page = 2048 Byte
#define	HwNFC_CTRL_PSIZE_4096		HwNFC_CTRL_PSIZE(4)				// 1 Page = 4096 Byte
#define	HwNFC_CTRL_PSIZE_MASK		HwNFC_CTRL_PSIZE(7)
#define	HwNFC_CTRL_CADDR			Hw0								// Number of Address Cycle

#define HwNFC_IRQCFG_RDYIEN			Hw31
#define HwNFC_IRQCFG_PIEN			Hw30
#define HwNFC_IRQCFG_RDIEN			Hw29


#define HwNFC_IRQ_MEDIRQ			Hw23
#define HwNFC_IRQ_PFG				Hw14
#define HwNFC_IRQ_RDFG				Hw13


#define	HwNFC_IREQ_FLAG2			Hw6								//
#define	HwNFC_IREQ_FLAG1			Hw5								//
#define	HwNFC_IREQ_FLAG0			Hw4								//
#define	HwNFC_IREQ_IRQ2				Hw2								// Ready Interrupt
#define	HwNFC_IREQ_IRQ1				Hw1								// Program Interrupt
#define	HwNFC_IREQ_IRQ0				Hw0								// Reading Interrupt

#define	HwECC_IREQ_MEDFG			Hw7								// MLC ECC Encoding Flag Register
#define	HwECC_IREQ_MEEFG			Hw6								// MLC ECC Decoding Flag Register
#define	HwECC_IREQ_SEDFG			Hw4								// SLC ECC Encoding Flag Register
#define	HwECC_IREQ_SEEFG			Hw3								// SLC ECC Decoding Flag Register

//--------------------------------------------------------------------------------------
// ECC Cotrol Register
//--------------------------------------------------------------------------------------
#define HwECC_BASE/*HwNFCECC_BASE*/                               *(volatile unsigned long*)0xB0050200

#define HwECC_CTRL_CORPASS_EN		Hw5								// MLC Correction Pass Enable
#define HwECC_CTRL_CORPASS_DIS		~Hw5							// MLC Correction Pass Disable
#define HwECC_CTRL_ECCMODE_NDM_EN	Hw4								// ECC Mode Selection( 0: Nor 1: NFC Dedicated Memory)
#define HwECC_CTRL_ECCMODE_NDM_DIS	~Hw4							// ECC Mode Selection( 0: Nor 1: NFC Dedicated Memory)

#define HwECC_CTRL_DSIZE_CLEAR		(Hw26|Hw25|Hw24|Hw23|Hw22|Hw21|Hw20|Hw19|Hw18|Hw17|Hw16)

#define	HwECC_CTRL_EN_SLCEN			Hw2								// SLC ECC Encoding Enable
#define	HwECC_CTRL_EN_SLCDE			(Hw2|Hw0)						// SLC ECC Decoding Enable
#define	HwECC_CTRL_EN_MCL4EN		(Hw2|Hw1)						// MLC ECC4 Encoding Enable
#define	HwECC_CTRL_EN_MCL4DE		(Hw2|Hw1|Hw0)					// MLC ECC4 Decoding Enable
#define	HwECC_CTRL_EN_MCL6EN		(Hw3)							// MLC ECC6 Encoding Enable
#define	HwECC_CTRL_EN_MCL6DE		(Hw3|Hw0)						// MLC ECC6 Decoding Enable
#define	HwECC_CTRL_EN_MCL12EN		(Hw3|Hw1)						// MLC ECC12 Encoding Enable
#define	HwECC_CTRL_EN_MCL12DE		(Hw3|Hw1|Hw0)					// MLC ECC12 Decoding Enable
#define	HwECC_CTRL_EN_MCL16EN		(Hw3|Hw2)						// MLC ECC16 Encoding Enable
#define	HwECC_CTRL_EN_MCL16DE		(Hw3|Hw2|Hw0)					// MLC ECC16 Decoding Enable
#define	HwECC_CTRL_EN_MCL24EN		(Hw3|Hw2|Hw1)					// MLC ECC24 Encoding Enable
#define	HwECC_CTRL_EN_MCL24DE		(Hw3|Hw2|Hw1|Hw0)				// MLC ECC24 Decoding Enable
#define	HwECC_CTRL_EN_DIS			~(Hw3|Hw2|Hw1|Hw0)				// ECC Disable

// ECC Error Number
#define	HwERR_NUM_ERR1				Hw0								// 1 Error Occurred(MLC4)
#define	HwERR_NUM_ERR2				Hw1								// 2 Error Occurred(MLC4)
#define	HwERR_NUM_ERR3				(Hw1|Hw0)						// 3 Error Occurred(MLC4)
#define	HwERR_NUM_ERR4				Hw2								// 4 Error Occurred(MLC4)
#define	HwERR_NUM_ERR5				(Hw2|Hw0)						// 5 Error Occurred(MLC4)
#define	HwERR_NUM_ERR6				(Hw2|Hw1)						// 6 Error Occurred(MLC4)
#define	HwERR_NUM_ERR7				(Hw2|Hw1|Hw0)					// 7 Error Occurred(MLC4)
#define	HwERR_NUM_ERR8				Hw3								// 8 Error Occurred(MLC4)
#define	HwERR_NUM_ERR9				(Hw3|Hw0)						// 9 Error Occurred(MLC4)
#define	HwERR_NUM_ERR10				(Hw3|Hw1)						// 10 Error Occurred(MLC4)
#define	HwERR_NUM_ERR11				(Hw3|Hw1|Hw0)					// 11 Error Occurred(MLC4)
#define	HwERR_NUM_ERR12				(Hw3|Hw2)						// 12 Error Occurred(MLC4)
#define	HwERR_NUM_ERR13				(Hw3|Hw2|Hw0)					// 13 Error Occurred(MLC4)
#define	HwERR_NUM_ERR14				(Hw3|Hw2|Hw1)					// 14 Error Occurred(MLC4)
#define	HwERR_NUM_ERR15				(Hw3|Hw2|Hw1|Hw0)				// 15 Error Occurred(MLC4)
#define	HwERR_NUM_ERR16				Hw4								// 16 Error Occurred(MLC4)
#define	HwERR_NUM_ERR17				(Hw4|Hw0)						// 17 Error Occurred(MLC4)
#define	HwERR_NUM_ERR18				(Hw4|Hw1)						// 18 Error Occurred(MLC4)
#define	HwERR_NUM_ERR19				(Hw4|Hw1|Hw0)					// 19 Error Occurred(MLC4)
#define	HwERR_NUM_ERR20				(Hw4|Hw2)						// 20 Error Occurred(MLC4)
#define	HwERR_NUM_ERR21				(Hw4|Hw2|Hw0)					// 21 Error Occurred(MLC4)
#define	HwERR_NUM_ERR22				(Hw4|Hw2|Hw1)					// 22 Error Occurred(MLC4)
#define	HwERR_NUM_ERR23				(Hw4|Hw2|Hw1|Hw0)				// 23 Error Occurred(MLC4)
#define	HwERR_NUM_ERR24				(Hw4|Hw3)						// 24 Error Occurred(MLC4)

#define	HwERR_NUM_NOERR				HwZERO							// No Error
#define	HwERR_NUM_CORIMP			(Hw4|Hw3|Hw0)					// Correction Impossible(SLC, MLC4)

#define HwNFCDMA_BASE                               *(volatile unsigned long*)0xB0050100
#define HwNFCSUBPAGE_BASE                           *(volatile unsigned long*)0xB0050120

#define HwNFCECCERR_BASE                            *(volatile unsigned long*)0xB0050260
#define HwNFCMEMORY_BASE                            *(volatile unsigned long*)0xB0050400

/************************************************************************
*   13. USB2.0 OTG Controller 0 Register Define      (Base Addr = 0xB0040000) // R/W
************************************************************************/
#define HwUSB20OTG_BASE                              *(volatile unsigned long*)0xB0040000
// Peripheral Bus CFG
#define HwUSBOTGCFG_BASE                             *(volatile unsigned long*)0xB0080020
#define HwUSBPHYCFG_BASE                             *(volatile unsigned long*)0xB0080024


/************************************************************************
*   14. I2C Controller Register Define              (Base Addr = 0xB0109000) // R/W
************************************************************************/
#define HwI2C_CORE0_BASE                            *(volatile unsigned long*)0xB0109000
#define HwI2C_CORE0_CH1_BASE                            *(volatile unsigned long*)0xB0109040
#define HwI2C_CORE0_SLAVE_BASE                            *(volatile unsigned long*)0xB0109080
#define HwI2C_CORE0_STATUS_BASE                            *(volatile unsigned long*)0xB01090C0

#define HwI2C_CORE1_BASE                            *(volatile unsigned long*)0xB0109100
#define HwI2C_CORE1_CH1_BASE                            *(volatile unsigned long*)0xB0109140
#define HwI2C_CORE1_SLAVE_BASE                            *(volatile unsigned long*)0xB0109180
#define HwI2C_CORE1_STATUS_BASE                            *(volatile unsigned long*)0xB01091C0

#define HwI2C_CORE2_BASE                            *(volatile unsigned long*)0xB0109200
#define HwI2C_CORE2_CH1_BASE                            *(volatile unsigned long*)0xB0109240
#define HwI2C_CORE2_SLAVE_BASE                            *(volatile unsigned long*)0xB0109280
#define HwI2C_CORE2_STATUS_BASE                            *(volatile unsigned long*)0xB01092C0



#define HwI2CIRQ_BASE                               *(volatile unsigned long*)0xB0109300
#define HwI2CDREQSEL_BASE                           *(volatile unsigned long*)0xB0109400


/************************************************************************
*   15. Pulse Density Modulation Register Define    (Base Addr = 0xB0060000) // R/W
************************************************************************/
#define HwPDM_BASE                                  *(volatile unsigned long*)0xB0060000

/************************************************************************
*   16. Remote Control Register Define              (Base Addr = 0xB0101000) // R/W
************************************************************************/
#define HwREMOTE_BASE                               *(volatile unsigned long*)0xB0101000


/************************************************************************
*   17. TSADC Controller Register Define            (Base Addr = 0xB0100000) // R/W
************************************************************************/
#define HwTSADC_BASE                                *(volatile unsigned long*)0xB0100000


/************************************************************************
*   18. TS Interface Register Define                (Base Addr = 0xB0108000) // R/W
************************************************************************/
#define HwTSIF_BASE                                 *(volatile unsigned long*)0xB0108000
#define HwTSIF0_BASE                                *(volatile unsigned long*)0xB0108000
#define HwTSIF1_BASE                                *(volatile unsigned long*)0xB0108100
#define HwTSIFPORTSEL_BASE                          *(volatile unsigned long*)0xB0108200

#define HwTSIF0PIDTABLE_BASE						*(volatile unsigned long*)0xB0108008
#define	HwTSIF0_PIDT(X)								*(volatile unsigned long *)(0xB0108008+(X)*4)	// R/W, PID Table Register

#define HwTSIF1PIDTABLE_BASE						*(volatile unsigned long*)0xB0108108
#define	HwTSIF1_PIDT(X)								*(volatile unsigned long *)(0xB0108108+(X)*4)	// R/W, PID Table Register

/************************************************************************
*   19. UART Controller Register Define             (Base Addr = 0xB0102000) // R/W
************************************************************************/
#define HwUART_BASE                                 *(volatile unsigned long*)0xB0102000
#define HwUART0_BASE                                *(volatile unsigned long*)0xB0102000
#define HwUART1_BASE                                *(volatile unsigned long*)0xB0102100
#define HwUART2_BASE                                *(volatile unsigned long*)0xB0102200
#define HwUART3_BASE                                *(volatile unsigned long*)0xB0102300
#define HwUART4_BASE                                *(volatile unsigned long*)0xB0102400
#define HwUART5_BASE                                *(volatile unsigned long*)0xB0102500
#define HwUARTPORTMUX_BASE                          *(volatile unsigned long*)0xB0102600

#define HwUART_CH_BASE(X)                           *(volatile unsigned long*)(0xB0102000+(X)*0x100)

#define	HwUART_CHSEL								HwUARTPORTMUX_BASE					// R/W, Channel Selection Register
#define HwUART_CHSEL_MASK(X)						(7<<((X)*4))						// X: Channel Number
#define HwUART_CHSEL_SEL_PORT(X,Y)					((Y)<<((X)*4))						// X: Channel Number, Y: Port Numbert

/************************************************************************
*   20. Vectored Priority Interrupt Controller Register Define (Base Addr = 0xB0600000) // R/W
************************************************************************/
#define HwVPIC_BASE                                 *(volatile unsigned long*)0xB0600000
#define HwPRIOINTRCTR_BASE                          *(volatile unsigned long*)0xB0600000
#define HwVECTINTRCTR_BASE                          *(volatile unsigned long*)0xB0600200
#define HwPIC_BASE                                  HwVPIC_BASE

#define HwPIC										((PPIC)&HwPIC_BASE)
#define HwVIC										((PVIC)&HwVECTINTRCTR_BASE)

// Interrupt Enable 0
#define	HwINT0_EHI0					Hw31										// R/W, External Host Interface0 Interrupt Enable

#define	HwINT0_DMA					Hw29										// R/W, DMA Controller Interrupt Enable
#define	HwINT0_TSADC				Hw28										// R/W, TSADC Interrupt Enable
#define	HwINT0_G2D					Hw27										// R/W, Graphic Engine 2D Hardware Interrupt Enable
#define	HwINT0_3DMMU				Hw26										// R/W, 3D MMU Interrupt Enable
#define	HwINT0_3DGP					Hw25										// R/W, 3D Geometary Interrupt Enable
#define	HwINT0_3DPP					Hw24										// R/W, 3D Pixel Processor Interrupt Enable
#define	HwINT0_VCDC					Hw23										// R/W, Video CODEC Interrupt Enable
#define	HwINT0_ISP2      			Hw22 										// R/W, ISP Interrupt Enable
#define	HwINT0_JPGE					Hw21										// R/W, JPEG Encoder Interrupt Enable
#define	HwINT0_VIPET				Hw20										// R/W, VIPET Controller Interrupt Enable
#define	HwINT0_LCD1					Hw19										// R/W, LCD Controller1 Interrupt Enable
#define	HwINT0_LCD0					Hw18										// R/W, LCD Controller0 Interrupt Enable
#define	HwINT0_CAM					Hw17										// R/W, Camera Interrupt Enable
#define	HwINT0_SC1					Hw16										// R/W, Mem-to-Mem Scaler1 Interrupt Enable
#define	HwINT0_SC0					Hw15										// R/W, Mem-to-Mem Scaler0 Interrupt Enable
#define	HwINT0_EI11					Hw14										// R/W, External Interrupt11 Enable
#define	HwINT0_EI10					Hw13										// R/W, External Interrupt10 Enable
#define	HwINT0_EI9					Hw12										// R/W, External Interrupt9 Enable
#define	HwINT0_EI8					Hw11										// R/W, External Interrupt8 Enable
#define	HwINT0_EI7					Hw10										// R/W, External Interrupt7 Enable
#define	HwINT0_EI6					Hw9											// R/W, External Interrupt6 Enable
#define	HwINT0_EI5					Hw8											// R/W, External Interrupt5 Enable
#define	HwINT0_EI4					Hw7											// R/W, External Interrupt4 Enable
#define	HwINT0_EI3					Hw6											// R/W, External Interrupt3 Enable
#define	HwINT0_EI2					Hw5											// R/W, External Interrupt2 Enable
#define	HwINT0_EI1					Hw4											// R/W, External Interrupt1 Enable
#define	HwINT0_EI0					Hw3											// R/W, External Interrupt0 Enable
#define	HwINT0_RTC					Hw2											// R/W, RTC Interrupt Enable
#define	HwINT0_TC32					Hw1											// R/W, Timer32 Interrupt Enable
#define	HwINT0_TC0					Hw0											// R/W, Timer0 Interrupt Enable

// Interrupt Enable 1
#define HwINT1_TSIF1				Hw22
#define HwINT1_TSIF0				Hw21
#define HwINT1_CIPHER				Hw20		
#define	HwINT1_UART					Hw15										// R/W, UART interrupt enable
#define HwINT1_RMT					Hw10										// R/W, CIPHER Interrupt Enable
#define HwINT1_GPSB					Hw4     

/************************************************************************
*   21. IO BUS Configuration Register Define        (Base Addr = 0xB0800000) // R/W
************************************************************************/
//#define HwIOBUSCFG_BASE                           *(volatile unsigned long*)0xB0800000 !!Error!!
#define HwIOBUSCFG_BASE                             *(volatile unsigned long*)0xB0080000







/*******************************************************************************
*    TCC9300 DataSheet PART 6 HSIO BUS
********************************************************************************/
/************************************************************************
*   4. USB2.0 OTG Controller 1 Register Define      (Base Addr = 0xB0800000) // R/W
*************************************************************************/
#define HwUSBOTG1_BASE                               *(volatile unsigned long*)0xB0800000
#define HwUSB20OTG1_BASE                             *(volatile unsigned long*)0xB0800000
// Peripheral Bus CFG
#define HwUSBOTG1CFG_BASE                            *(volatile unsigned long*)0xB0880010
#define HwUSBPHY1CFG_BASE                            *(volatile unsigned long*)0xB0880014

/************************************************************************
*   5. Memory Stick Controller Register Define      (Base Addr = 0xB0840000) // R/W
*************************************************************************/
#define HwMSTICK_BASE                               *(volatile unsigned long*)0xB0840000

/************************************************************************
*   5-1. Memory Stick Controller Config Register Define (Base Addr = 0xB0870100) // R/W
*************************************************************************/
#define HwMSTICKCFG_BASE                            *(volatile unsigned long*)0xB0870100

/************************************************************************
*   6, 7, 8. SATA Controller Register Define              (Base Addr = 0xB0810000) // R/W
*************************************************************************/
#define HwSATA_BASE                                  *(volatile unsigned long*)0xB0810000
#define HwSATAHOST_BASE                              *(volatile unsigned long*)0xB0810000
#define HwSATADEVICE_BASE                            *(volatile unsigned long*)0xB0850000
#define HwSATAPHY_BASE                               *(volatile unsigned long*)0xB0860000
#define HwSTATPHYCMU_BASE                            *(volatile unsigned long*)0xB0860000
#define HwSTATPHYLANE_BASE                           *(volatile unsigned long*)0xB0860200
#define HwSTATPHYCLANE_BASE                          *(volatile unsigned long*)0xB0860A00



/************************************************************************
*   9. Ethernet MAC Controller Register Define      (Base Addr = 0xB0820000) // R/W
*************************************************************************/
#define HwGMAC_BASE                                 *(volatile unsigned long*)0xB0820000
#define HwGMACTIMESTAMP_BASE                        *(volatile unsigned long*)0xB0820700
#define HwGMACADDR_BASE                             *(volatile unsigned long*)0xB0820800
#define HwGMACDMA_BASE                              *(volatile unsigned long*)0xB0821000


/************************************************************************
*   10. Cipher Controller Register Define           (Base Addr = 0xB0870000) // R/W
*************************************************************************/
#define HwCIPHER_BASE                               *(volatile unsigned long*)0xB0870000

/************************************************************************
*   11. HSIO Bus Configuration Register Define      (Base Addr = 0xB0880000) // R/W
*************************************************************************/
#define HwHSIOBUSCFG_BASE                           *(volatile unsigned long*)0xB0880000
/************************************************************************
*   11-1. HSIO Bus Matrix Register Define           (Base Addr = 0xB0870200) // R/W
*************************************************************************/
#define HwHSIOBUSMATRIX_BASE                        *(volatile unsigned long*)0xB0870200






/*******************************************************************************
*    TCC9300 DataSheet PART 7 DISPLAY Bus
********************************************************************************/
/************************************************************************
*   4. LCD Controller Register Define               (Base Addr = 0xB0A00000) // R/W
*************************************************************************/
#define HwLCDC_BASE                                 *(volatile unsigned long*)0xB0A00000
#define HwLCDC0_BASE                                *(volatile unsigned long*)0xB0A00000
#define HwLCDC1_BASE                                *(volatile unsigned long*)0xB0A04000


#define HwLCD						((PLCDC)&HwLCDC0_BASE)
#define HwLCD1						((PLCDC)&HwLCDC1_BASE)

// LCD Control
#define	HwLCTRL_EVP					Hw31										// External Vsync Polarity
#define	HwLCTRL_EVS					Hw30										// External Vsync Enable
#define	HwLCTRL_R2YMD				(Hw29+Hw28+Hw27+Hw26)						// RGB to YCbCr Conversion Option
#define	HwLCTRL_GEN					Hw25										// Gamma Correction Enable Bit
#define	HwLCTRL_656					Hw24										// CCIR 656 Mode
#define	HwLCTRL_CKG					Hw23										// Clock Gating Enable for Timing Generator
#define	HwLCTRL_BPP					(Hw22+Hw21+Hw20)							// Bit Per Pixel for STN_LCD
#define	HwLCTRL_PXDW				(Hw19+Hw18+Hw17+Hw16)						// PXDW
#define	HwLCTRL_ID					Hw15										// Inverted Data Enable
#define	HwLCTRL_IV					Hw14										// Inverted Vertical Sync
#define	HwLCTRL_IH					Hw13										// Inverted Horizontal Sync
#define	HwLCTRL_IP					Hw12										// Inverted Pixel Clock
#define	HwLCTRL_CLEN				Hw11										// Clipping Enable
#define	HwLCTRL_DP					Hw10										// Double Pixel Data
#define	HwLCTRL_R2Y					Hw9											// RGB to YCbCr Converter Enable for Output 
#define	HwLCTRL_NI					Hw8											// Non-Interlace
#define	HwLCTRL_TV					Hw7											// TV mode 
#define	HwLCTRL_TFT					Hw6											// TFT LCD mode
#define	HwLCTRL_STN					Hw5											// STN LCD mode
#define	HwLCTRL_MSEL				Hw4											// Master Select for Image 0
#define	HwLCTRL_OVP					(Hw3+Hw2+Hw1)								// Overlay priority
#define	HwLCTRL_LEN					Hw0											// LCD Controller Enable

// LCD Clock Divider
#define	HwLCLKDIV_CS				Hw31										// Clock Source		
#define	HwLCLKDIV_ACDIV				Hw16										// AC bias clock divisor (STN only)
#define	HwLCLKDIV_LCLKDIV			Hw8											// LCLK clocks divider 
#define	HwLCLKDIV_PXCLKDIV			(Hw8 - Hw0)											// Pixel Clock Divider

// LCD Vertical Timing 1
#define	HwLVTIME1_VDB				Hw27										// Back porchVSYNC delay	
#define	HwLVTIME1_VDF				Hw22										// Front porch of VSYNC delay	
#define	HwLVTIME1_FPW				Hw16										// Frame pulse width	 
#define	HwLVTIME1_FLC				Hw0											// Frame line count	 

// LCD Status
#define	HwLSTATUS_VS				Hw31										// Monitoring vertical sync
#define	HwLSTATUS_BUSY				Hw30										// Busy signal
#define	HwLSTATUS_EF				Hw29										// Even-Field(Read Only). 0:Odd field or frame, 1:Even field or frame
#define	HwLSTATUS_DEOF				Hw28										// DMA End of Frame flag
#define	HwLSTATUS_I0EOF				Hw27										// Image 0 End of Frame flag
#define	HwLSTATUS_I1EOF				Hw26										// Image 1 End of Frame flag
#define	HwLSTATUS_I2EOF				Hw25										// Image 2 End of Frame flag
#define	HwLSTATUS_IE2F				Hw12										// Image 2 end-of-frame falling edge flag
#define	HwLSTATUS_IE2R				Hw11										// Image 2 end-of-frame rising edge flag
#define	HwLSTATUS_IE1F				Hw10										// Image 1 end-of-frame falling edge flag
#define	HwLSTATUS_IE1R				Hw9											// Image 1 end-of-frame rising edge flag
#define	HwLSTATUS_IE0F				Hw8											// Image 0 end-of-frame falling edge flag
#define	HwLSTATUS_IE0R				Hw7											// Image 0 end-of-frame rising edge flag
#define	HwLSTATUS_DEF				Hw6											// DMA end-of-frame falling edge flag
#define	HwLSTATUS_DER				Hw5											// DMA end-of-frame rising edge flag
#define	HwLSTATUS_DD				Hw4											// Disable done
#define	HwLSTATUS_RU				Hw3											// Register update flag
#define	HwLSTATUS_VSF				Hw2											// VS falling flag
#define	HwLSTATUS_VSR				Hw1											// VS rising flag
#define	HwLSTATUS_FU				Hw0											// LCD output fifo under-run flag.

// LCD Interrupt
#define	HwLIM_FU					Hw0											//LCD output fifo under-run interrupt mask
#define	HwLIM_VSR					Hw1											// VS rising interrupt mask
#define	HwLIM_VSF					Hw2											// VS falling interrupt mask
#define	HwLIM_RU					Hw3											// Register update interrupt mask
#define	HwLIM_DD					Hw4											// Disable done interrupt mask
#define	HwLIM_DER					Hw5											// DMA end-of-frame rising edge interrupt mask
#define	HwLIM_DEF					Hw6											// DMA end-of-frame falling edge interrupt mask
#define	HwLIM_IE0R					Hw7											// Image 0 end-of-frame rising edge interrupt mask
#define	HwLIM_IE0F					Hw8											// Image 0 end-of-frame falling edge interrupt mask
#define	HwLIM_IE1R					Hw9											// Image 1 end-of-frame rising edge interrupt mask
#define	HwLIM_IE1F					Hw10										// Image 1 end-of-frame falling edge interrupt mask
#define	HwLIM_IE2R					Hw11										// Image 2 end-of-frame rising edge interrupt mask
#define	HwLIM_IE2F					Hw12										// Image 2 end-of-frame falling edge interrupt mask

// LCD Image Control
#define	HwLIC_INTL					Hw31										// DMA interlace type
#define	HwLIC_AEN					Hw30										// AlphaBlending Function for Each Image
#define	HwLIC_CEN					Hw29										// Chroma-Key Function for Each Image
#define	HwLIC_IEN					Hw28										// Image Display Function for Each Image
#define	HwLIC_SRC					Hw27										// Image Source Select
#define	HwLIC_AOPT					(Hw26+Hw25)									// Alpha -blending Option Selection Bits
#define	HwLIC_ASEL					Hw24										// Image Displaying Function for Each Image
#define	HwLIC_UPD					Hw16										// data update enable
#define	HwLIC_PD					Hw15										// Bit padding
#define	HwLIC_Y2RMD					(Hw10+Hw9)									// YCbCr to RGB Conversion Option
#define	HwLIC_Y2R					Hw8											// YCbCr to RGB Conversion Enable Bit
#define	HwLIC_BR					Hw7											// Bit Reverse
#define	HwLIC_FMT					(Hw4+Hw3+Hw2+Hw1+Hw0)						// Image Format


// LCD Image Scale Ratio
#define	HwLISCALE_Y					(Hw7+Hw6+Hw5+Hw4)							// Y DownScale
#define	HwLISCALE_X					(Hw3+Hw2+Hw1+Hw0)							// X DownScale

// LCD Alpha Information
#define	HwLIA_A0					(Hw24-Hw16)									// Alpha Value 0
#define	HwLIA_A1					(Hw8-Hw0)									// Alpha Value 1

// LCD Chroma-key 
#define	HwLICKEY					(Hw8-Hw0)									// Chroma key 
#define	HwLICKEYMASK				(Hw24-Hw16)									// Chroma key mask






/************************************************************************
*   5. LCD System Interface Register Define         (Base Addr = 0xB0A08000) // R/W
*************************************************************************/
#define HwLCDSI_BASE                                *(volatile unsigned long*)0xB0A08000
#define HwLCDSI0_BASE                               *(volatile unsigned long*)0xB0A08000
#define HwLCDSI1_BASE                               *(volatile unsigned long*)0xB0A0C000

/************************************************************************
*   6. Memory to Memory Scaler Register Define      (Base Addr = 0xB0A10000) // R/W
*************************************************************************/
#define HwM2MSCALER_BASE                            *(volatile unsigned long*)0xB0A10000
#define HwM2MSCALER0_BASE                           *(volatile unsigned long*)0xB0A10000
#define HwM2MSCALER1_BASE                           *(volatile unsigned long*)0xB0A20000
#define HwM2MSCALER0								((PM2MSCALER)&HwM2MSCALER0_BASE)
#define HwM2MSCALER1								((PM2MSCALER)&HwM2MSCALER1_BASE)

#define HwSCALERPOSTFILTER_BASE                     *(volatile unsigned long*)0xB0A5B000

#define HwM2MSCALER_CFG0			*(volatile unsigned long*)0xB0A10014
#define HwM2MSCALER_CFG1			*(volatile unsigned long*)0xB0A20014

//-------------------------------------------- Scaler0 --------------------------------------------
// Scaler source image Y base address
#define	HwMSC_SRC_Y_BASE_ADDR		0xFFFFFFFC									// HwMSC_SRC_Y_BASE_ADDR [31: 2]		// Scaler source image Y base
// Scaler source image U base address
#define	HwMSC_SRC_U_BASE_ADDR		0xFFFFFFFC									// HwMSC_SRC_U_BASE_ADDR [31: 2]		// Scaler source image U base
// Scaler source image V base address
#define	HwMSC_SRC_V_BASE_ADDR		0xFFFFFFFC									// HwMSC_SRC_V_BASE_ADDR [31: 2]		// Scaler source image V base

// Source image size
#define	HwMSC_SRC_SIZE_H			0x00000FFF									// HwMSC_SRC_SIZE_H [11: 0]		// Input image Horizontal size by pixel
#define	HwMSC_SRC_SIZE_V			0x0FFF0000									// HwMSC_SRC_SIZE_V [27: 16]		// Input image Vertical size by pixel

// Source image line offset
#define	HwMSC_SRC_OFFSET_Y			0x00000FFF									// HwMSC_SRC_OFFSET_Y [11: 0]		// Input image line offset of luminace
#define	HwMSC_SRC_OFFSET_C			0x0FFF0000									// HwMSC_SRC_OFFSET_C [27: 16]		// Input image line offset of chrominance

// Source image Configuration
#define   HwMSC_SRC_CFG_MSBF			Hw31
#define   HwMSC_SRC_CFG_OMODE			Hw19
#define   HwMSC_SRC_CFG_IMODE			Hw17
#define   HwMSC_SRC_CFG_ARGB			Hw16
#define	HwMSC_SRC_CFG_INTM			Hw5											// interleaved mode cb/cr order	[5]
#define   HwMSC_SRC_CFG_INPATH			Hw4
#define	HwMSC_SRC_CFG_INTLV			Hw3											// interleaved type [3]
#define	HwMSC_SRC_CFG_YUV422_SEQ0	HwZERO										// YUV422 SEQuential order 0
#define	HwMSC_SRC_CFG_YUV422_SEQ1	Hw0											// YUV422 SEQuential order 1
#define	HwMSC_SRC_CFG_YUV422_SEP	Hw1											// YUV422 SEPERATED
#define	HwMSC_SRC_CFG_YUV420_SEP	(Hw1|Hw0)									// YUV420 SEPERATED
#define	HwMSC_SRC_CFG_RGB565		Hw2											// YUV422 SEPERATED
#define	HwMSC_SRC_CFG_RGB555		(Hw2|Hw0)									// YUV422 SEPERATED
#define	HwMSC_SRC_CFG_RGB444		(Hw2|Hw1)									// YUV422 SEPERATED
#define	HwMSC_SRC_CFG_RGB454		(Hw2|Hw1|Hw0)
//#define	HwMSC_SRC_CFG_INVALID		(Hw2|Hw1|Hw0)								// INVALID

// Scaler destination image Y base address
#define	HwMSC_DST_Y_BASE_ADDR		0xFFFFFFFC									// HwMSC_DST_Y_BASE_ADDR [31: 2]		// Scaler destination image Y base
// Scaler destination image U base address
#define	HwMSC_DST_U_BASE_ADDR		0xFFFFFFFC									// HwMSC_DST_U_BASE_ADDR [31: 2]		// Scaler destination image U base
// Scaler destination image V base address
#define	HwMSC_DST_V_BASE_ADDR		0xFFFFFFFC									// HwMSC_DST_V_BASE_ADDR [31: 2]		// Scaler destination image V base

// Destination image size
#define	HwMSC_DST_SIZE_H			0x00000FFF									// HwMSC_DST_SIZE_H	[11: 0]		// Input image Horizontal size by pixel
#define	HwMSC_DST_SIZE_V			0x0FFF0000									// HwMSC_DST_SIZE_V	[27: 16]		// Input image Vertical size by pixel

// Destination image line offset
#define	HwMSC_DST_OFFSET_Y			0x00000FFF									// HwMSC_DST_OFFSET_Y [11: 0]		// Input image line offset of luminace
#define	HwMSC_DST_OFFSET_C			0x0FFF0000									// HwMSC_DST_OFFSET_C [27: 16]		// Input image line offset of chrominance

// Destination image Configuration
#define	HwMSC_DST_CFG_COP			Hw11										// COP	[11]
#define	HwMSC_DST_CFG_WAIT			0x00000700									// WAIT	[10:8]
#define	HwMSC_DST_CFG_RDY			Hw6											// READY [6]
#define	HwMSC_DST_CFG_INTM			Hw5											// interleaved mode cb/cr order	[5]
#define	HwMSC_DST_CFG_PATH			Hw4											// [4]	0 : to memory (Master mode, Scaler master writes result to memory)
#define	HwMSC_DST_CFG_INTLV			Hw3											// interleaved type [3]

// 070802_hjb		//	1 : LCD (Slave mode, LCD master reads scaling results)
#define	HwMSC_DST_CFG_YUV422_SEQ0	HwZERO										// YUV422 SEQuential order 0
#define	HwMSC_DST_CFG_YUV422_SEQ1	Hw0											// YUV422 SEQuential order 1
#define	HwMSC_DST_CFG_YUV422_SEP	Hw1											// YUV422 SEPERATED
#define	HwMSC_DST_CFG_YUV420_SEP	(Hw1|Hw0)									// YUV420 SEPERATED
#define	HwMSC_DST_CFG_RGB565		Hw2											// YUV422 SEPERATED
#define	HwMSC_DST_CFG_RGB555		(Hw2|Hw0)									// YUV422 SEPERATED
#define	HwMSC_DST_CFG_RGB444		(Hw2|Hw1)									// YUV422 SEPERATED
#define	HwMSC_DST_CFG_RGB454		(Hw2|Hw1|Hw0)
//#define	HwMSC_DST_CFG_INVALID		(Hw2|Hw1|Hw0)								// INVALID

// Scale ratio
#define	HwMSC_HRATIO				0x00003FFF									// HwMSC_HRATIO [29:16] Horizontal scale factor
#define	HwMSC_VRATIO				0x3FFF0000									// HwMSC_VRATIO [13:0]	Vertical scale factor

// Scaler control
#define	HwMSC_INPTH					Hw24										// Rolling Operation Mode Enable
#define	HwMSC_REN					Hw23										// Rolling Operation Mode Enable
#define	HwMSC_MEN					Hw22										// middle Operation Mode Enable
#define	HwMSC_RLS					Hw19										// Release Stop mode
#define	HwMSC_RGSM					Hw17										// Rolling Go Stop Mode 
#define	HwMSC_MGSM					Hw16										// Middle Go Stop Mode
#define	HwMSC_RIRQEN				Hw7											// Rolling interrupt enable
#define	HwMSC_MIRQEN				Hw6											// Middle interrupt enable
#define	HwMSC_CTRL_CON_EN			Hw5	
#define	HwMSC_CTRL_BUSY_EN			Hw2											// HwMSC_CTRL_BUSY_EN [2] Scaler BUSY interrupt enable
#define	HwMSC_CTRL_RDY_EN			Hw1											// HwMSC_CTRL_RDY_EN	[1] Scaler READY intertupt enable
#define	HwMSC_CTRL_EN				Hw0											// HwMSC_CTRL_EN	[0] Scaler enable

// Scaler status
#define	HwMSC_IR					Hw7											// Rolling interrupt flag
#define	HwMSC_IM					Hw6											// Middle interrupt flag
#define	HwMSC_STATUS_IBUSY			Hw5											// HwMSC_STATUS_IBUSY [5] BUSY INTERRUPT FLAG
#define	HwMSC_STATUS_IRDY			Hw4											// HwMSC_STATUS_IRDY	[4] READY INTERRUPT FLAG
#define	HwMSC_STATUS_BUSY			Hw1											// HwMSC_STATUS_BUSY  [1] BUSY Status FLAG
#define	HwMSC_STATUS_RDY			Hw0											// HwMSC_STATUS_RDY	[0] READY Status FLAG


#define	HwMSC_DST_ROLL_CNT			0x0FFF0000
#define	HwMSC_DST_MID_CNT			0x00000FFF

#define	HwMSC_C_R_CNT				0x0FFF0000


/************************************************************************
*   7. TV Encoder Controller Register Define        (Base Addr = 0xB0A40000) // R/W
*************************************************************************/
#define HwTVENCODER_BASE                            *(volatile unsigned long*)0xB0A40000
#define	HwTVE_BASE					                HwTVENCODER_BASE

#define HwTVE_VEN_BASE								*(volatile unsigned long*)0xB0A40800
#define HwTVE_VEN									((PNTSCPALOP)&HwTVE_VEN_BASE)

// Encoder Mode Control A
#define	HwTVECMDA_PWDENC_PD			Hw7											// Power down mode for entire digital logic of TV encoder
#define	HwTVECMDA_FDRST_1			Hw6											// Chroma is free running as compared to H-sync
#define	HwTVECMDA_FDRST_0			HwZERO										// Relationship between color burst & H-sync is maintained for video standards
#define	HwTVECMDA_FSCSEL(X)			((X)*Hw4)
#define	HwTVECMDA_FSCSEL_NTSC		HwTVECMDA_FSCSEL(0)							// Color subcarrier frequency is 3.57954545 MHz for NTSC
#define	HwTVECMDA_FSCSEL_PALX		HwTVECMDA_FSCSEL(1)							// Color subcarrier frequency is 4.43361875 MHz for PAL-B,D,G,H,I,N
#define	HwTVECMDA_FSCSEL_PALM		HwTVECMDA_FSCSEL(2)							// Color subcarrier frequency is 3.57561149 MHz for PAL-M
#define	HwTVECMDA_FSCSEL_PALCN		HwTVECMDA_FSCSEL(3)							// Color subcarrier frequency is 3.58205625 MHz for PAL-combination N
#define	HwTVECMDA_FSCSEL_MASK		HwTVECMDA_FSCSEL(3)
#define	HwTVECMDA_PEDESTAL			Hw3											// Video Output has a pedestal
#define	HwTVECMDA_NO_PEDESTAL		HwZERO										// Video Output has no pedestal
#define	HwTVECMDA_PIXEL_SQUARE		Hw2											// Input data is at square pixel rates.
#define	HwTVECMDA_PIXEL_601			HwZERO										// Input data is at 601 rates.
#define	HwTVECMDA_IFMT_625			Hw1											// Output data has 625 lines
#define	HwTVECMDA_IFMT_525			HwZERO										// Output data has 525 lines
#define	HwTVECMDA_PHALT_PAL			Hw0											// PAL encoded chroma signal output
#define	HwTVECMDA_PHALT_NTSC		HwZERO										// NTSC encoded chroma signal output

// Encoder Mode Control B
#define	HwTVECMDB_YBIBLK_BLACK		Hw4											// Video data is forced to Black level for Vertical non VBI processed lines.
#define	HwTVECMDB_YBIBLK_BYPASS		HwZERO										// Input data is passed through forn non VBI processed lines.
#define	HwTVECMDB_CBW(X)			((X)*Hw2)
#define	HwTVECMDB_CBW_LOW			HwTVECMDB_CBW(0)							// Low Chroma band-width
#define	HwTVECMDB_CBW_MEDIUM		HwTVECMDB_CBW(1)							// Medium Chroma band-width
#define	HwTVECMDB_CBW_HIGH			HwTVECMDB_CBW(2)							// High Chroma band-width
#define	HwTVECMDB_CBW_MASK			HwTVECMDB_CBW(3)							// 
#define	HwTVECMDB_YBW(X)			((X)*Hw0)
#define	HwTVECMDB_YBW_LOW			HwTVECMDB_YBW(0)							// Low Luma band-width
#define	HwTVECMDB_YBW_MEDIUM		HwTVECMDB_YBW(1)							// Medium Luma band-width
#define	HwTVECMDB_YBW_HIGH			HwTVECMDB_YBW(2)							// High Luma band-width
#define	HwTVECMDB_YBW_MASK			HwTVECMDB_YBW(3)							// 

// Encoder Clock Generator
#define	HwTVEGLK_XT24_24MHZ			Hw4											// 24MHz Clock input
#define	HwTVEGLK_XT24_27MHZ			HwZERO										// 27MHz Clock input
#define	HwTVEGLK_GLKEN_RST_EN		Hw3											// Reset Genlock
#define	HwTVEGLK_GLKEN_RST_DIS		~Hw3										// Release Genlock
#define	HwTVEGLK_GLKE(X)			((X)*Hw1)
#define	HwTVEGLK_GLKE_INT			HwTVEGLK_GLKE(0)							// Chroma Fsc is generated from internal constants based on current user setting
#define	HwTVEGLK_GLKE_RTCO			HwTVEGLK_GLKE(2)							// Chroma Fsc is adjusted based on external RTCO input
#define	HwTVEGLK_GLKE_CLKI			HwTVEGLK_GLKE(3)							// Chroma Fsc tracks non standard encoder clock (CLKI) frequency
#define	HwTVEGLK_GLKE_MASK			HwTVEGLK_GLKE(3)							//
#define	HwTVEGLK_GLKEN_GLKPL_HIGH	Hw0											// PAL ID polarity is active high
#define	HwTVEGLK_GLKEN_GLKPL_LOW	HwZERO										// PAL ID polarity is active low

// Encoder Mode Control C
#define	HwTVECMDC_CSMDE_EN			Hw7											// Composite Sync mode enabled
#define	HwTVECMDC_CSMDE_DIS			~Hw7										// Composite Sync mode disabled (pin is tri-stated)
#define	HwTVECMDC_CSMD(X)			((X)*Hw5)
#define	HwTVECMDC_CSMD_CSYNC		HwTVECMDC_CSMD(0)							// CSYN pin is Composite sync signal
#define	HwTVECMDC_CSMD_KEYCLAMP		HwTVECMDC_CSMD(1)							// CSYN pin is Keyed clamp signal
#define	HwTVECMDC_CSMD_KEYPULSE		HwTVECMDC_CSMD(2)							// CSYN pin is Keyed pulse signal
#define	HwTVECMDC_CSMD_MASK			HwTVECMDC_CSMD(3)
#define	HwTVECMDC_RGBSYNC(X)		((X)*Hw3)
#define	HwTVECMDC_RGBSYNC_NOSYNC	HwTVECMDC_RGBSYNC(0)						// Disable RGBSYNC (when output is configured for analog EGB mode)
#define	HwTVECMDC_RGBSYNC_RGB		HwTVECMDC_RGBSYNC(1)						// Sync on RGB output signal (when output is configured for analog EGB mode)
#define	HwTVECMDC_RGBSYNC_G			HwTVECMDC_RGBSYNC(2)						// Sync on G output signal (when output is configured for analog EGB mode)
#define	HwTVECMDC_RGBSYNC_MASK		HwTVECMDC_RGBSYNC(3)

// DAC Output Selection
#define	HwTVEDACSEL_DACSEL_CODE0	HwZERO										// Data output is diabled (output is code '0')
#define	HwTVEDACSEL_DACSEL_CVBS		Hw0											// Data output in CVBS format

// DAC Power Down
#define	HwTVEDACPD_PD_EN			Hw0											// DAC Power Down Enabled
#define	HwTVEDACPD_PD_DIS			~Hw0										// DAC Power Down Disabled

// Sync Control
#define	HwTVEICNTL_FSIP_ODDHIGH		Hw7											// Odd field active high
#define	HwTVEICNTL_FSIP_ODDLOW		HwZERO										// Odd field active low
#define	HwTVEICNTL_VSIP_HIGH		Hw6											// V-sync active high
#define	HwTVEICNTL_VSIP_LOW			HwZERO										// V-sync active low
#define	HwTVEICNTL_HSIP_HIGH		Hw5											// H-sync active high
#define	HwTVEICNTL_HSIP_LOW			HwZERO										// H-sync active low
#define	HwTVEICNTL_HSVSP_RISING		Hw4											// H/V-sync latch enabled at rising edge
#define	HwTVEICNTL_HVVSP_FALLING	HwZERO										// H/V-sync latch enabled at falling edge
#define	HwTVEICNTL_VSMD_START		Hw3											// Even/Odd field H/V sync output are aligned to video line start
#define	HwTVEICNTL_VSMD_MID			HwZERO										// Even field H/V sync output are aligned to video line midpoint
#define	HwTVEICNTL_ISYNC(X)			((X)*Hw0)
#define	HwTVEICNTL_ISYNC_FSI		HwTVEICNTL_ISYNC(0)							// Alignment input format from FSI pin
#define	HwTVEICNTL_ISYNC_HVFSI		HwTVEICNTL_ISYNC(1)							// Alignment input format from HSI,VSI,FSI pin
#define	HwTVEICNTL_ISYNC_HVSI		HwTVEICNTL_ISYNC(2)							// Alignment input format from HSI,VSI pin
#define	HwTVEICNTL_ISYNC_VFSI		HwTVEICNTL_ISYNC(3)							// Alignment input format from VSI,FSI pin
#define	HwTVEICNTL_ISYNC_VSI		HwTVEICNTL_ISYNC(4)							// Alignment input format from VSI pin
#define	HwTVEICNTL_ISYNC_ESAV_L		HwTVEICNTL_ISYNC(5)							// Alignment input format from EAV,SAV codes (line by line)
#define	HwTVEICNTL_ISYNC_ESAV_F		HwTVEICNTL_ISYNC(6)							// Alignment input format from EAV,SAV codes (frame by frame)
#define	HwTVEICNTL_ISYNC_FREE		HwTVEICNTL_ISYNC(7)							// Alignment is free running (Master mode)
#define	HwTVEICNTL_ISYNC_MASK		HwTVEICNTL_ISYNC(7)

// Offset Control
#define	HwTVEHVOFFST_INSEL(X)		((X)*Hw6)
#define	HwTVEHVOFFST_INSEL_BW16_27MHZ		HwTVEHVOFFST_INSEL(0)				// 16bit YUV 4:2:2 sampled at 27MHz
#define	HwTVEHVOFFST_INSEL_BW16_13P5MH		HwTVEHVOFFST_INSEL(1)				// 16bit YUV 4:2:2 sampled at 13.5MHz
#define	HwTVEHVOFFST_INSEL_BW8_13P5MHZ		HwTVEHVOFFST_INSEL(2)				// 8bit YUV 4:2:2 sampled at 13.5MHz
#define	HwTVEHVOFFST_INSEL_MASK		HwTVEHVOFFST_INSEL(3)
#define	HwTVEHVOFFST_VOFFST_256		Hw3											// Vertical offset bit 8 (Refer to HwTVEVOFFST)
#define	HwTVEHVOFFST_HOFFST_1024	Hw2											// Horizontal offset bit 10 (Refer to HwTVEHOFFST)
#define	HwTVEHVOFFST_HOFFST_512		Hw1											// Horizontal offset bit 9 (Refer to HwTVEHOFFST)
#define	HwTVEHVOFFST_HOFFST_256		Hw0											// Horizontal offset bit 8 (Refer to HwTVEHOFFST)

// Sync Output Control
#define	HwTVEHSVSO_VSOB_256			Hw6											// VSOB bit 8 (Refer to HwVSOB)
#define	HwTVEHSVSO_HSOB_1024		Hw5											// HSOB bit 10 (Refer to HwHSOB)
#define	HwTVEHSVSO_HSOB_512			Hw4											// HSOB bit 9 (Refer to HwHSOB)
#define	HwTVEHSVSO_HSOB_256			Hw3											// HSOB bit 8 (Refer to HwHSOB)
#define	HwTVEHSVSO_HSOE_1024		Hw2											// HSOE bit 10 (Refer to HwHSOE)
#define	HwTVEHSVSO_HSOE_512			Hw1											// HSOE bit 9 (Refer to HwHSOE)
#define	HwTVEHSVSO_HSOE_256			Hw0											// HSOE bit 8 (Refer to HwHSOE)

// Trailing Edge of Vertical Sync Control
#define	HwTVEVSOE_VSOST(X)			((X)*Hw6)									// Programs V-sync relative location for Odd/Even Fields.
#define	HwTVEVSOE_NOVRST_EN			Hw5											// No vertical reset on every field
#define	HwTVEVSOE_NOVRST_NORMAL		HwZERO										// Normal vertical reset operation (interlaced output timing)
#define	HwTVEVSOE_VSOE(X)			((X)*Hw0)									// Trailing Edge of Vertical Sync Control

// VBI Control Register
#define	HwTVEVCTRL_VBICTL(X)		((X)*Hw5)									// VBI Control indicating the current line is VBI.
#define	HwTVEVCTRL_VBICTL_NONE		HwTVEVCTRL_VBICTL(0)						// Do nothing, pass as active video.
#define	HwTVEVCTRL_VBICTL_10LINE	HwTVEVCTRL_VBICTL(1)						// Insert blank(Y:16, Cb,Cr: 128), for example, 10 through 21st line.
#define	HwTVEVCTRL_VBICTL_1LINE		HwTVEVCTRL_VBICTL(2)						// Insert blank data 1 line less for CC processing.
#define	HwTVEVCTRL_VBICTL_2LINE		HwTVEVCTRL_VBICTL(3)						// Insert blank data 2 line less for CC and CGMS processing.
#define	HwTVEVCTRL_MASK				HwTVEVCTRL_VBICTL(3)					
#define	HwTVEVCTRL_CCOE_EN			Hw4											// Closed caption odd field enable.
#define	HwTVEVCTRL_CCEE_EN			Hw3											// Closed caption even field enable.
#define	HwTVEVCTRL_CGOE_EN			Hw2											// Copy generation management system enable odd field.
#define	HwTVEVCTRL_CGEE_EN			Hw1											// Copy generation management system enable even field.
#define	HwTVEVCTRL_WSSE_EN			Hw0											// Wide screen enable.

// Connection between LCDC & TVEncoder Control
#define	HwTVEVENCON_EN_EN			Hw0											// Connection between LCDC & TVEncoder Enabled
#define	HwTVEVENCON_EN_DIS			~Hw0										// Connection between LCDC & TVEncoder Disabled

// I/F between LCDC & TVEncoder Selection
#define	HwTVEVENCIF_MV_1			Hw1											// reserved
#define	HwTVEVENCIF_FMT_1			Hw0											// PXDATA[7:0] => CIN[7:0], PXDATA[15:8] => YIN[7:0]
#define	HwTVEVENCIF_FMT_0			HwZERO										// PXDATA[7:0] => YIN[7:0], PXDATA[15:8] => CIN[7:0]

/************************************************************************
*   8. HDMI Controller Register Define              (Base Addr = 0xB0A54000) // R/W
*************************************************************************/
#define HwHDMI_BASE                                 *(volatile unsigned long*)0xB0A54000
#define HwHDMICTRL_BASE                             *(volatile unsigned long*)0xB0A54000
#define HwHDMICORE_BASE                             *(volatile unsigned long*)0xB0A55000
#define HwHDMIAES_BASE                              *(volatile unsigned long*)0xB0A56000
#define HwHDMISPDIF_BASE                            *(volatile unsigned long*)0xB0A57000
#define HwHDMII2S_BASE                              *(volatile unsigned long*)0xB0A58000
#define HwHDMICEC_BASE                              *(volatile unsigned long*)0xB0A59000

/************************************************************************
*   9. Video and Image Enhancer Register Define     (Base Addr = 0xB0A52000) // R/W
*************************************************************************/
#define HwVIQE_BASE                                 *(volatile unsigned long*)0xB0A52000
#define HwVIQELUT_BASE                              *(volatile unsigned long*)0xB0A53000

/************************************************************************
*   10. DDI Configuration Register Define           (Base Addr = 0xB0A51000) // R/W
*************************************************************************/
#define HwDDICFG_BASE                               *(volatile unsigned long*)0xB0A51000
#define HwDDI_CONFIG_BASE							HwDDICFG_BASE
#define HwDDI_CONFIG								((PDDICONFIG)&HwDDI_CONFIG_BASE)

// HDMI Control register
#define	HwDDIC_HDMI_CTRL_SEL_LCDC1	Hw15
#define	HwDDIC_HDMI_CTRL_SEL_LCDC0	HwZERO
#define	HwDDIC_HDMI_CTRL_EN			Hw14
#define	HwDDIC_HDMI_CTRL_RST_HDMI	Hw0
#define	HwDDIC_HDMI_CTRL_RST_SPDIF	Hw1
#define	HwDDIC_HDMI_CTRL_RST_TMDS	Hw2
#define	HwDDIC_HDMI_CTRL_RST_NOTUSE	Hw3

// Power Down
#define	HwDDIC_PWDN_LCDSI1			Hw9											// LCD SI Interface
#define	HwDDIC_PWDN_HDMI			Hw8											// HDMI Interface
#define	HwDDIC_PWDN_DDIC			Hw7											// DDIBUS Cache
#define	HwDDIC_PWDN_MSCL1			Hw6											// Memory Scaler 1
#define	HwDDIC_PWDN_MSCL0			Hw5											// Memory Scaler 0
#define	HwDDIC_PWDN_LCDSI			Hw4											// LCDSI Interface
#define	HwDDIC_PWDN_LCDC1			Hw3											// LCD 1 Interface
#define	HwDDIC_PWDN_LCDC0			Hw2											// LCD 0 Interface
#define	HwDDIC_PWDN_VIQE			Hw1											// Video Image Quality Enhancer
#define	HwDDIC_PWDN_CIF				Hw0											// Camera Interface

// Soft Reset
#define	HwDDIC_SWRESET_LCDSI1		Hw9											// LCD SI Interface
#define	HwDDIC_SWRESET_HDMI			Hw8											// HDMI Interface
#define	HwDDIC_SWRESET_DDIC			Hw7											// DDIBUS Cache
#define	HwDDIC_SWRESET_MSCL1		Hw6											// Memory Scaler 1
#define	HwDDIC_SWRESET_MSCL0		Hw5											// Memory Scaler 0
#define	HwDDIC_SWRESET_LCDSI		Hw4											// LCDSI Interface
#define	HwDDIC_SWRESET_LCDC1		Hw3											// LCD 1 Interface
#define	HwDDIC_SWRESET_LCDC0		Hw2											// LCD 0 Interface
#define	HwDDIC_SWRESET_VIQE			Hw1											// Video Image Quality Enhancer
#define	HwDDIC_SWRESET_CIF			Hw0											// Camera Interface
/************************************************************************
*   11. DDI Cache Register Define                   (Base Addr = 0xB0A50000) // R/W
*************************************************************************/
#define HwDDICACHE_BASE                             *(volatile unsigned long*)0xB0A50000
#define HwDDI_CACHE_BASE                            HwDDICACHE_BASE

#define	HwDDI_LCD0_DMA_0_0			0
#define	HwDDI_LCD0_DMA_0_1			1
#define	HwDDI_LCD0_DMA_0_2			2
#define	HwDDI_LCD0_DMA_1			3
#define	HwDDI_LCD0_DMA_2			4
#define	HwDDI_MSCL0_DMA_0			5
#define	HwDDI_MSCL0_DMA_1			6	
#define	HwDDI_MSCL0_DMA_2			7
#define	HwDDI_VIQE_DMA_0_0			8
#define	HwDDI_VIQE_DMA_0_1			9
#define	HwDDI_VIQE_DMA_0_2			10

#define	DDIC_LCD1_DMA_0_0			0
#define	DDIC_LCD1_DMA_0_1			1
#define	DDIC_LCD1_DMA_0_2			2
#define	DDIC_LCD1_DMA_1				3
#define	DDIC_LCD1_DMA_2				4
#define	DDIC_MSCL1_DMA_0			5
#define	DDIC_MSCL1_DMA_1			6
#define	DDIC_MSCL1_DMA_2			7
#define	DDIC_VIQE_DMA_1_0			8
#define	DDIC_VIQE_DMA_1_1			9
#define	DDIC_VIQE_DMA_1_2			10
#define	DDIC_VIQE_DMA_2_0			11
#define	DDIC_VIQE_DMA_2_1			12
#define	DDIC_VIQE_DMA_2_2			13


/*******************************************************************************
*    TCC9300 DataSheet PART 8 Video Bus
********************************************************************************/
/************************************************************************
*   4,5,6,7. JPEG Codec / Video Codec Register Define            (Base Addr = 0xB0900000) // R/W
*************************************************************************/

/************************************************************************
*   4. JPEG Encoder Register Define                              (Base Addr = 0xB0980000) // R/W
*************************************************************************/
#define HwJPEGENCODER_BASE                          *(volatile unsigned long*)0xB0980000
#define HwJPEGENC									((PJPEGENCODER)&HwJPEGENCODER_BASE)

/* R/W, JPEG Codec Mode Register */
#define	HwJP_MOD_JPC					HwZERO								/* JPEG Encoder Mode */
#define	HwJP_MOD_JPD					Hw16								/* JPEG Decoder Mode */
#define	HwJP_MOD_MASTER					HwZERO								/* Master Mode */  
#define	HwJP_MOD_SLAVE					Hw0									/* Slave Mode */

/* R/W, Interrupt Mask Register */
#define HwJP_INT_MASK_OPERATION_END		Hw0       								/* Encode/Decode Complete */
#define HwJP_INT_MASK_ERROR             Hw1       								/* Encode/Decode Error */
#define HwJP_INT_MASK_OUTPUT_FIFO       Hw2       								/* Output FIFO Buffer Status */
#define HwJP_INT_MASK_INPUT_FIFO		Hw3       								/* Input FIFO Buffer Status */
#define HwJP_INT_MASK_CODED_BUFFER		Hw4       								/* Output Buffer's Full/Empty Status */
#define HwJP_INT_MASK_YBUF_ROLLING      Hw5

/* R/W, Polling or Interrupt Mode Selection Register */
#define	HwJP_TRG_MOD_POLL				HwZERO								/* Polling Mode. No Interrupt Generated */
#define	HwJP_TRG_MOD_INT				Hw0									/* Interrupt Mode */

/* R/W, Image Format Information Register */
#define	HwJP_CHROMA_YONLY				HwZERO								/* Y Only */
#define	HwJP_CHROMA_420					Hw0									/* YUV420 (Y,U,V Separated Mode) */
#define	HwJP_CHROMA_422					Hw1									/* YUV422 (Y,U,V Separated Mode) */
#define	HwJP_CHROMA_444					(Hw0|Hw1)							/* YUV444 (Y,U,V Separated Mode) */
#define	HwJP_CHROMA_422S				Hw2									/* YUV422S (Y,U,V Separated Mode) */

/*  DECODE ONLY : R/W, Decoder Output Scaling Register*/ 
#define	HwJPD_OUT_SCL_4					Hw0									/* 1/4 (Area Ratio) */
#define	HwJPD_OUT_SCL_16				Hw1									/* 1/16 (Area Ratio) */

/* W, Codec Start Command Register */
#define	HwJP_START_RUN					Hw0									/*  Codec Start   */

/* R, Interrupt Flag Register */
#define	HwJP_INT_FLAG_YBUF_ROLLING		Hw5										/* Y Buffer Rolling Interrupt Status */
#define	HwJP_INT_FLAG_CODED_BUF_STAT	Hw4									/* Coded Buffer Status */
#define	HwJP_INT_FLAG_IFIFO_STAT		Hw3									/* Input FIFO Status */
#define	HwJP_INT_FLAG_OFIFO_STAT		Hw2									/* Output FIFO Status */
#define	HwJP_INT_FLAG_DECODING_ERR		Hw1									/* Decoding Error */
#define	HwJP_INT_FLAG_JOB_FINISHED		Hw0									/* Job Finished */


/************************************************************************
*   5. Video Codec Register Define                               (Base Addr = 0xB0900000) // R/W
*************************************************************************/
#define HwVIDEOCODEC_BASE                           *(volatile unsigned long*)0xB0900000


/************************************************************************
*   6. Video Cache Register Define                               (Base Addr = 0xB0910000) // R/W
*************************************************************************/
#define HwVIDEOCACHE_BASE                           *(volatile unsigned long*)0xB0910000
#define HwVIDEOCACHE								((PVIDEOCACHE)&HwVIDEOCACHE_BASE)

// Video Cache Ctrl
#define	HwVIDEOCACHE_PWRASVE 				Hw31								// Video Cache
#define	HwVIDEOCACHE_CACHEON				Hw0									// Video Codec

// Video Cache Region Enable
#define	HwVIDEOCACHE_WRITE3_EN				Hw13								// Read reasion 3  Enable
#define	HwVIDEOCACHE_READ3_EN				Hw12								// Write reasion 3  Enable
#define	HwVIDEOCACHE_WRITE2_EN				Hw9									// Read reasion 2  Enable
#define	HwVIDEOCACHE_READ2_EN				Hw8								       // Write reasion 2  Enable
#define	HwVIDEOCACHE_WRITE1_EN				Hw5									// Read reasion 1  Enable
#define	HwVIDEOCACHE_READ1_EN				Hw4									// Write reasion 1  Enable
#define	HwVIDEOCACHE_WRITE0_EN				Hw1									// Read reasion 0  Enable
#define	HwVIDEOCACHE_READ0_EN				Hw0									// Write reasion 0  Enable

// VWB Ctrl
#define	HwVIDEOCACHE_VWB_TIMEOUT_VALUE		0xFFFF0000							// Timeout value.
#define	HwVIDEOCACHE_VWB_WCBV				Hw5									// Write cache bvalid option.
#define	HwVIDEOCACHE_VWB_RESET				Hw3									// Reset.
#define	HwVIDEOCACHE_VWB_STATUS				Hw2								       // Read only drain status.
#define	HwVIDEOCACHE_VWB_TIMEOUT_EN			Hw1									// Timeout enable.
#define	HwVIDEOCACHE_VWB_DRAIN_EN			Hw0									// Drain enable


/************************************************************************
*   7. Video Bus Register Define                                 (Base Addr = 0xB0910000) // R/W
*************************************************************************/
#define HwVIDEOBUSCFG_BASE                          *(volatile unsigned long*)0xB0920000
#define HwVIDEOBUSCFG								((PVIDEOBUSCFG)&HwVIDEOBUSCFG_BASE)

// Power Down
#define	HwVIDEOC_PWDN_VIDEO_CACHE 			Hw3									// Video Cache
#define	HwVIDEOC_PWDN_VIDEO_CODEC			Hw2									// Video Codec
#define	HwVIDEOC_PWDN_JPEG_DECODER			Hw1									// Jpeg decoder
#define	HwVIDEOC_PWDN_JPEG_ENCODER			Hw0									// Jpeg Encoder

// Soft Reset
#define	HwVIDEOC_SWRESET_VIDEO_CACHE 		Hw3									// Video Cache
#define	HwVIDEOC_SWRESET_VIDEO_CODEC		Hw2									// Video Codec
#define	HwVIDEOC_SWRESET_JPEG_DECODER		Hw1									// Jpeg decoder
#define	HwVIDEOC_SWRESET_JPEG_ENCODER		Hw0									// Jpeg Encoder




/*******************************************************************************
*    TCC9300 DataSheet PART 9 Camera Bus
********************************************************************************/
/************************************************************************
*   4.3 Camera Interface Register Define             (Base Addr = 0xB0200000) // R/W
*************************************************************************/
#define HwCIF_BASE                                  *(volatile unsigned long*)0xB0200000
#define HwCIF                                       ((PCIF)&HwCIF_BASE)

// Input Image Color/Pattern Configuration 1
#define	HwICPCR1_ON 				Hw31										// On/Off on CIF >> 0:Can't operate CIF , 1:Operating CIF
#define	HwICPCR1_PWD				Hw30										// Power down mode in camera >> 0:Disable, 1:Power down mode , This power down mode is connected the PWDN of camera sensor
#define	HwICPCR1_TV					Hw29										// TV signal   0: CIF sync signal, 1: TV sync signal
#define	HwICPCR1_TI					Hw28										// Vertical blasnk insert   0: Do not insert vertical blank in even field, 1: insert vertical blank in 1 line in even field
#define	HwICPCR1_UF					Hw27										// Use field signal (in interlace mode, it is decided whether field signal is used or not)  0: Don't Use , 1: Use field signal
#define	HwICPCR1_ITEN				Hw26										// Interlace enable, This field must be set in case of interlace input mode. 0: Disable , 1: Enable
#define	HwICPCR1_FS					Hw25										// Field port signal select (Select field port input between field signal and HS, when the field signal is used in interlace mode)
                                                                                                                                            	// 0: Field signal , 1: Horizontal sync
#define	HwICPCR1_FP					Hw24										// Field port polarity 0: Active low(odd field- high, HS-active low) , 1: Active High (odd field - low, HS-active High)
#define	HwICPCR1_BPS				Hw23										// Bypass Scaler >> 0:Non(CIF Scaler is used), 1:Bypass(CIF Scaler is not used)
#define	HwICPCR1_POL				Hw21										// PXCLK Polarity >> 0:Rising edge, Positive edge, 1:Falling edge, Negative edge
#define	HwICPCR1_SKPF				(Hw20|Hw19|Hw18)							// Skip Frame >> 0~7 #Frames skips	[20:18]
#define	HwICPCR1_M420_ZERO			HwZERO										// Format Convert (YUV422->YUV420) , Not-Convert
#define	HwICPCR1_M420_ODD			Hw17										// converted in odd line skip
#define	HwICPCR1_M420_EVEN			(Hw17|Hw16)									// converted in even line skip
#define	HwICPCR1_BP					Hw15										// Bypass(Non-Separate, if value is 1, and Separate if vlaue is 0) Data format to be stored to memory
																				 	// when BP value is 1, If M420 bit is set to 0, the data format is YUV422, Otherwise, the data format is YUV420
#define	HwICPCR1_BBS_LSB8			Hw14										// When bypass 16bits mode, LSB 8bits are stored in first
#define	HwICPCR1_C656				Hw13										// Convert 656 format 0:Disable, 1:Enable
#define	HwICPCR1_CP_RGB				Hw12										// RGB(555,565,bayer) color pattern
#define	HwICPCR1_PF_444				HwZERO										// 4:4:4 format    // "01" SHOULD BE WRITTEN TO THIS BIT
#define	HwICPCR1_PF_422				Hw10										// 4:2:2 format
#define	HwICPCR1_PF_420				Hw11										// 4:2:0 format or RGB(555,565,bayer) mode
#define	HwICPCR1_RGBM_BAYER			HwZERO										// Bayer RGB Mode
#define	HwICPCR1_RGBM_RGB555		Hw8											// RGB555 Mode
#define	HwICPCR1_RGBM_RGB565		Hw9											// RGB565 Mode
#define	HwICPCR1_RGBBM_16			HwZERO										// 16bit mode
#define	HwICPCR1_RGBBM_8DISYNC		Hw6											// 8bit disable sync
#define	HwICPCR1_RGBBM_8			Hw7											// 8bit mode
#define	HwICPCR1_CS_RGBMG			HwZERO										// 555RGB:RGB(MG), 565RGB:RGB, 444/422/420:R/Cb/U first, Bayer RGB:BG->GR, CCIR656:YCbYCr
#define	HwICPCR1_CS_RGBLG			Hw4											// 555RGB:RGB(LG), 565RGB:RGB, 444/422/420:R/Cb/U first, Bayer RGB:GR->BG, CCIR656:YCrYCb
#define	HwICPCR1_CS_BGRMG			Hw5											// 555RGB:BGR(MG), 565RGB:BGR, 444/422/420:B/Cr/V first, Bayer RGB:RG->GB, CCIR656:CbYCrY
#define	HwICPCR1_CS_BGRLG			(Hw5|Hw4)									// 555RGB:BGR(LG), 565RGB:BGR, 444/422/420:B/Cr/V first, Bayer RGB:GB->RG, CCIR656:CrYCbY
#define	HwICPCR1_BO_SW				Hw2											// Switch the MSB/LSB 8bit Bus, 1 (default , Don't change)
#define	HwICPCR1_HSP_HIGH			Hw1											// Horizontal Sync Polarity 1: Active high (default)
#define	HwICPCR1_VSP_HIGH			Hw0											// Vertical Sync Polarity 1: Active high (default)

// CCIR656 Format Configuration 1
#define	Hw656FCR1_PSL_1ST			HwZERO										// The status word is located the first byte of EAV & SAV
#define	Hw656FCR1_PSL_2ND			Hw25										// The status word is located the second byte of EAV & SAV
#define	Hw656FCR1_PSL_3RD			Hw26										// The status word is located the third byte of EAV & SAV
#define	Hw656FCR1_PSL_4TH			(Hw26|Hw25)									// The status word is located the forth byte of EAV & SAV
																				//FPV [23:16] 0x00FF0000,	SPV [15:8] 0x0000FF00, TPV [7:0]	0x000000FF
// CMOSIF DMA Configuratin 1
#define	HwCDCR1_TM_INC				Hw3											// INC Transfer
#define	HwCDCR1_LOCK_ON				Hw2											// Lock Transfer
#define	HwCDCR1_BS_1				HwZERO										// The DMA transfers the image data as 1 word to memory
#define	HwCDCR1_BS_2				Hw0											// The DMA transfers the image data as 2 word to memory
#define	HwCDCR1_BS_4				Hw1											// The DMA transfers the image data as 4 word to memory
#define	HwCDCR1_BS_8				(Hw1|Hw0)									// The DMA transfers the image data as 8 word to memory (default)

// FIFO Status
#define	HwFIFOSTATE_CLR				Hw21										// Clear FIFO states, 1:Clear, 0:Not Clear
#define	HwFIFOSTATE_REO				Hw19										// Overlay FIFO Read ERROR,	1:The empty signal of input overlay FIFO and read enable signal are High, 0:The empty signal of overlay FIFO is low, or empty is High and read enable signal is Low.
#define	HwFIFOSTATE_REV				Hw18										// V(B) Channel FiFO Read ERROR, 1:The empty signal of input V(B) channel FIFO and read enable signal are High, 0:The empty signal of V(B) channel FIFO is Low, or empty is High and read enable signal is Low.
#define	HwFIFOSTATE_REU				Hw17										// U(R) Channel FiFO Read ERROR, 1:The empty signal of input U(R) channel FIFO and read enable signal are High, 0:The empty signal of U(R) channel FIFO is Low, or empty is High and read enable signal is Low.
#define	HwFIFOSTATE_REY				Hw16										// Y(G) Channel FiFO Read ERROR, 1:The empty signal of input Y(G) channel FIFO and read enable signal are High, 0:The empty signal of Y(G) channel FIFO is Low, or empty is High and read enable signal is Low.
#define	HwFIFOSTATE_WEO				Hw13										// Overlay FIFO Write ERROR, 1:The full signal of overlay FIFO and write enable signal are High, 0:The full signal of overlay FIFO is Low, or full is High and write enable signal is Low.
#define	HwFIFOSTATE_WEV				Hw12										// V(B) Channel FiFO Write ERROR, 1:The full signal of V(B) channel FIFO and write enable signal are High, 0:The full signal of V(B) channel FIFO is Low, or full is High and write enable signal is Low.
#define	HwFIFOSTATE_WEU				Hw11										// U(R) Channel FiFO Write ERROR, 1:The full signal of U(R) channel FIFO and write enable signal are High, 0:The full signal of U(R) channel FIFO is Low, or full is High and write enable signal is Low.
#define	HwFIFOSTATE_WEY				Hw10										// Y(G) Channel FiFO Write ERROR, 1:The full signal of Y channel FIFO and write enable signal are High, 0:The full signal of Y channel FIFO is Low, or full is High and write enable signal is Low.
#define	HwFIFOSTATE_EO				Hw8											// Overlay FIFO Empty Signal, 1:The state of overlay FIFO is empty, 0:The state of overlay FIFO is non-empty.
#define	HwFIFOSTATE_EV				Hw7											// V(B) Channel FiFO Empty Signal, 1:The state of V(B) channel FIFO is empty, 0:The state of V(B) channel FIFO is non-empty.
#define	HwFIFOSTATE_EU				Hw6											// U(R) Channel FiFO Empty Signal, 1:The state of U(R) channel FIFO is empty, 0:The state of U(R) channel FIFO is non-empty.
#define	HwFIFOSTATE_EY				Hw5											// Y(G) Channel FiFO Empty Signal, 1:The state of Y channel FIFO is empty, 0:The state of Y channel FIFO is non-empty.
#define	HwFIFOSTATE_FO				Hw3											// Overlay FiFO FULL Signal, 1:The state of overlay FIFO is full, 0:The state of overlay FIFO is non-full.
#define	HwFIFOSTATE_FV				Hw2											// V(B) Channel FiFO FULL Signal, 1:The state of V(B) channel FIFO is full, 0:The state of V(B) channel FIFO is non-full.
#define	HwFIFOSTATE_FU				Hw1											// U(R) Channel FiFO FULL Signal, 1:The state of U(R) channel FIFO is full, 0:The state of U(R) channel FIFO is non-full.
#define	HwFIFOSTATE_FY				Hw0											// Y(G) Channel FiFO FULL Signal, 1:The state of Y(G) channel FIFO is full, 0:The state of Y(G) channel FIFO is non-full.

// Interrupt & CIF Operating
#define	HwCIRQ_IEN					Hw31										// Interrupt Enable	0:interrupt disable, 1:interrupt enable
#define	HwCIRQ_URV					Hw30										// Update Register in VSYNC	0:Register is update without VSYNC , 1:When VSYNC is posedge, register is updated.
#define	HwCIRQ_ITY					Hw29										// Interrupt Type	0:Pulse type, 1:Hold-up type when respond signal(ICR) is high
#define	HwCIRQ_ICR					Hw28										// Interrupt Clear 0:.... , 1:Interrupt Clear (using ITY is Hold-up type)
#define	HwCIRQ_MVN					Hw26										// Mask interrupt of VS negative edge,	0:Don't mask, 1:Mask
#define	HwCIRQ_MVP					Hw25										// Mask interrupt of VS positive edge,	0:Don't mask, 1:Mask
#define	HwCIRQ_MVIT					Hw24										// Mask interrupt of VCNT Interrupt,	0:Don't mask, 1:Mask
#define	HwCIRQ_MSE					Hw23										// Mask interrupt of Scaler Error,	0:Don't mask, 1:Mask
#define	HwCIRQ_MSF					Hw22										// Mask interrupt of Scaler finish,	0:Don't mask, 1:Mask
#define	HwCIRQ_MENS					Hw21										// Mask interrupt of Encoding start,	0:Don't mask, 1:Mask
#define	HwCIRQ_MRLV					Hw20										// Mask interrupt of Rolling V address,	0:Don't mask, 1:Mask
#define	HwCIRQ_MRLU					Hw19										// Mask interrupt of Rolling U address,	0:Don't mask, 1:Mask
#define	HwCIRQ_MRLY					Hw18										// Mask interrupt of Rolling Y address,	0:Don't mask, 1:Mask
#define	HwCIRQ_MSCF					Hw17										// Mask interrupt of Capture frame,	0:Don't mask, 1:Mask
#define	HwCIRQ_MSOF					Hw16										// Mask interrupt of Stored one frame,	0:Don't mask, 1:Mask
#define	HwCIRQ_SFEN					Hw15										// Generate SOF mode in interlace,	0:Generate SOF when 2-field images are stored memory.
																					//  1:Without field number, generate SOF when 1-field image is stored memory
#define	HwCIRQ_VSS					Hw12										// Status of vertical sync, Non-vertical sync blank area.
#define	HwCIRQ_FL					Hw11										// Field signal states, 0: even field,  1: Odd field
#define	HwCIRQ_VN					Hw10										// VS negative, 0:-, 1:When VS is generated if negative edge
#define	HwCIRQ_VP					Hw9											// VS positive, 0:-, 1:When VS is generated if positive edge
#define	HwCIRQ_VIT					Hw8											// VCNT Interrupt, 0:-, 1:When VCNT is generated....
#define	HwCIRQ_SE					Hw7											// Scaler Error, 0:-, 1:When Scale operation is not correct.
#define	HwCIRQ_SF					Hw6											// Scaler Finish, 0:-, 1:When Scale operation is finished
#define	HwCIRQ_ENS					Hw5											// Encoding start status, 0:-, 1:When Y address is bigger than encoding start address, this bit is high
#define	HwCIRQ_ROLV					Hw4											// Rolling V address status, 0:-, 1:If V address is move to start address, this bit is high
#define	HwCIRQ_ROLU					Hw3											// Rolling U address starus, 0:-, 1:If U address is move to start address, this bit is high 
#define	HwCIRQ_ROLY					Hw2											// Rolling Y address starus, 0:-, 1:If Y address is move to start address, this bit is high 
#define	HwCIRQ_SCF					Hw1											// Stored captured frame,	0:-, 1:If Captured frame is stored, this bit is high
#define	HwCIRQ_SOF					Hw0											// Stored One frame, 0-, 1:If one frame if stored, this bit is high.

// EINT  by kch
#define HwEINTSEL2_EINT15(X)		((X)*Hw24)									// EINT15 Source Selection
#define HwEINTSEL2_EINT15_MASK		HwEINTSEL2_EINT11(0x7F)
#define HwEINTSEL2_EINT14(X)		((X)*Hw16)									// EINT14 Source Selection
#define HwEINTSEL2_EINT14_MASK		HwEINTSEL2_EINT10(0x7F)
#define HwEINTSEL2_EINT13(X) 		((X)*Hw8)									// EINT13 Source Selection
#define HwEINTSEL2_EINT13_MASK		HwEINTSEL2_EINT9(0x7F)
#define HwEINTSEL2_EINT12(X) 		((X)*Hw0)									// EINT12 Source Selection
#define HwEINTSEL2_EINT12_MASK		HwEINTSEL2_EINT8(0x7F)
#define HwEINTSEL2_EINT11(X)		((X)*Hw24)									// EINT11 Source Selection
#define HwEINTSEL2_EINT11_MASK		HwEINTSEL2_EINT11(0x7F)
#define HwEINTSEL2_EINT10(X)		((X)*Hw16)									// EINT10 Source Selection
#define HwEINTSEL2_EINT10_MASK		HwEINTSEL2_EINT10(0x7F)
#define HwEINTSEL2_EINT9(X) 		((X)*Hw8)									// EINT9 Source Selection
#define HwEINTSEL2_EINT9_MASK		HwEINTSEL2_EINT9(0x7F)
#define HwEINTSEL2_EINT8(X) 		((X)*Hw0)									// EINT8 Source Selection
#define HwEINTSEL2_EINT8_MASK		HwEINTSEL2_EINT8(0x7F)
#define HwEINTSEL1_EINT7(X) 		((X)*Hw24)									// EINT7 Source Selection
#define HwEINTSEL1_EINT7_MASK		HwEINTSEL1_EINT7(0x7F)
#define HwEINTSEL1_EINT6(X) 		((X)*Hw16)									// EINT6 Source Selection
#define HwEINTSEL1_EINT6_MASK		HwEINTSEL1_EINT6(0x7F)
#define HwEINTSEL1_EINT5(X) 		((X)*Hw8)									// EINT5 Source Selection
#define HwEINTSEL1_EINT5_MASK		HwEINTSEL1_EINT5(0x7F)
#define HwEINTSEL1_EINT4(X) 		((X)*Hw0)									// EINT4 Source Selection
#define HwEINTSEL1_EINT4_MASK		HwEINTSEL1_EINT4(0x7F)
#define HwEINTSEL0_EINT3(X) 		((X)*Hw24)									// EINT3 Source Selection
#define HwEINTSEL0_EINT3_MASK		HwEINTSEL0_EINT3(0x7F)
#define HwEINTSEL0_EINT2(X) 		((X)*Hw16)									// EINT2 Source Selection
#define HwEINTSEL0_EINT2_MASK		HwEINTSEL0_EINT2(0x7F)
#define HwEINTSEL0_EINT1(X) 		((X)*Hw8)									// EINT1 Source Selection
#define HwEINTSEL0_EINT1_MASK		HwEINTSEL0_EINT1(0x7F)
#define HwEINTSEL0_EINT0(X) 		((X)*Hw0)									// EINT0 Source Selection
#define HwEINTSEL0_EINT0_MASK		HwEINTSEL0_EINT0(0x7F)

// Interrupt Selection
typedef enum
{
	SEL_GPIOA0, 	SEL_GPIOA1, 	SEL_GPIOA2, 	SEL_GPIOA3, 	SEL_GPIOA4, 	// 0
	SEL_GPIOA5, 	SEL_GPIOA6, 	SEL_GPIOA7, 	SEL_GPIOA8, 	SEL_GPIOA9, 	// 5
	SEL_GPIOA10,	SEL_GPIOA11,	SEL_GPIOA12,	SEL_GPIOA13,	SEL_GPIOA14,	// 10
	SEL_GPIOA15,	SEL_GPIOA16, 	SEL_GPIOA17, 	SEL_GPIOB17, 	SEL_GPIOB19, 	// 15
	SEL_GPIOB26, 	SEL_GPIOB27,	SEL_GPIOB30,	SEL_GPIOB31,	SEL_GPIOC18,	// 20
	SEL_GPIOC19,	SEL_GPIOC20,	SEL_GPIOC21,	SEL_GPIOC22,	SEL_GPIOC23,	// 25
	SEL_GPIOC28,	SEL_GPIOC29,	SEL_GPIOC30,	SEL_GPIOC31,	SEL_GPIOD15,	// 30
	SEL_GPIOD16,	SEL_GPIOD17,	SEL_GPIOD18,	SEL_GPIOD19,	SEL_GPIOD20, 	// 35
	SEL_GPIOD21,	SEL_GPIOD22,	SEL_GPIOD23,	SEL_GPIOD24,	SEL_GPIOD25, 	// 40
	SEL_GPIOE10,	SEL_GPIOE11,	SEL_GPIOE24,	SEL_GPIOE25,	SEL_GPIOE26,	// 45
	SEL_GPIOE27, 	SEL_GPIOE28,	SEL_GPIOE29, 	SEL_GPIOE30, 	SEL_GPIOE31,	// 50
	SEL_GPIOF16,	SEL_GPIOF17,	SEL_GPIOF26, 	SEL_GPIOF27, 	SEL_GPIOF28,     // 55
	SEL_GPIOG4 ,	SEL_GPIOG5,		SEL_GPIOG6, 	SEL_GPIOG7, 	SEL_GPIOG11,     // 60
	SEL_GPIOG12,	SEL_GPIOG17,	SEL_GPIOG22, 	SEL_GPIOG23, 	SEL_GPIOG24,     // 65	
	SEL_GPIOG25,	SEL_GPIOG26,	SEL_GPIOG27, 	SEL_GPIOG28, 	SEL_GPIOG29,     // 70		
	SEL_TSWKU,		SEL_TSSTOP,		SEL_TSUPDN, 	SEL_RMWKUP, 	SEL_USB1_VBON,     // 75			
	SEL_USB1_VBOFF,	SEL_USB0_VBON,	SEL_USB0_VBOFF					// 80
} ESEL;
 

// Overlay Control 1
#define	HwOCTRL1_OCNT_MAX			(Hw29|Hw28|Hw27|Hw26|Hw25|Hw24)				//[28:24] Overlay Count FIFO (Hw27|Hw26|Hw25|Hw24|Hw23)
#define	HwOCTRL1_OM_BLOCK			Hw16										// Overlay Method 0:Full image overlay, 1:Block image overlay	, Full image overlay mode, overlay image size is equal to the input image size.
#define	HwOCTRL1_OE_EN				Hw12										// Overlay enable 0:Disable, 1:Enable
#define	HwOCTRL1_XR1_100			Hw10										// XOR in AP1 is 3 (100%)	0:XOR operation, 1:100%	, When AP1 is 3 and CEN & AEN is 1, We select the 100% alpha value or XOR.
#define	HwOCTRL1_XR0_100			Hw9											// XOR in AP0 is 3 (100%)	0:XOR operation, 1:100%	, When AP0 is 3 and CEN & AEN is 1, We select the 100% alpha value or XOR.
#define	HwOCTRL1_AP1_25				HwZERO										// Alpha Value in alpha is 1		// 25%			
#define	HwOCTRL1_AP1_50				Hw6											// Alpha Value in alpha is 1		// 50%
#define	HwOCTRL1_AP1_75				Hw7											// Alpha Value in alpha is 1		// 75%				
#define	HwOCTRL1_AP1_100			(Hw7|Hw6)									// Alpha Value in alpha is 1		// 100% or XOR operation (for XR value)
#define	HwOCTRL1_AP0_25				HwZERO										// Alpha Value in alpha is 0		// 25%			
#define	HwOCTRL1_AP0_50				Hw4											// Alpha Value in alpha is 0		// 50%
#define	HwOCTRL1_AP0_75				Hw5											// Alpha Value in alpha is 0		// 75%				
#define	HwOCTRL1_AP0_100			(Hw5|Hw4)									// Alpha Value in alpha is 0		// 100% or XOR operation
																				// When 565RGB and AEN, alpha value is depend on AP0 value.
#define	HwOCTRL1_AEN_EN				Hw2											// Alpha enable	0:Disable, 1:Enable
#define	HwOCTRL1_CEN_EN				Hw0											// Chroma key enable	0:Disable, 1:Enable

// Overlay Control 2 
#define	HwOCTRL2_CONV				Hw3											// Color Converter Enable 0:Disable, 1:Enable 
#define	HwOCTRL2_RGB_565			HwZERO										// RGB mode 565RGB 
#define	HwOCTRL2_RGB_555			Hw1											// RGB mode 555RGB
#define	HwOCTRL2_RGB_444			Hw2											// RGB mode 444RGB
#define	HwOCTRL2_RGB_332			(Hw2|Hw1)									// RGB mode 332RGB
#define	HwOCTRL2_MD					Hw0											// Color Mode	0:YUV Color, 1:RGB color

// Overlay Control 3 -- KEY Value 
#define	HwOCTRL3_KEYR_MAX			0x00FF0000									// Chroma-key value R(U), Chroea-key value in R(U) channel, Default value is 0x00
#define	HwOCTRL3_KEYG_MAX			0x0000FF00									// Chroma-key value G(Y), Chroea-key value in G(Y) channel, Default value is 0x00
#define	HwOCTRL3_KEYB_MAX			0x000000FF									// Chroma-key value B(V), Chroea-key value in B(V) channel, Default value is 0x00
 
// Overlay Control 4 -- Mask KEY Value
#define	HwOCTRL4_MKEYR_MAX			0x00FF0000									// Mask Chroma-key value R(U), Chroea-key value in R(U) channel, Default value is 0x00
#define	HwOCTRL4_MKEYG_MAX			0x0000FF00									// Mask Chroma-key value G(Y), Chroea-key value in G(Y) channel, Default value is 0x00
#define	HwOCTRL4_MKEYB_MAX			0x000000FF									// Mask Chroma-key value B(V), Chroea-key value in B(V) channel, Default value is 0x00

// Camera Down Scaler
#define	HwCDS_SFH_1					HwZERO										// Horizontal Scale Factor, 1/1 down scale
#define	HwCDS_SFH_2					Hw4											// Horizontal Scale Factor, 1/2 down scale
#define	HwCDS_SFH_4					Hw5											// Horizontal Scale Factor, 1/4 down scale
#define	HwCDS_SFH_8					(Hw5|Hw4)									// Horizontal Scale Factor, 1/8 down scale
#define	HwCDS_SFV_1					HwZERO										// Vertical Scale Factor, 1/1 down scale
#define	HwCDS_SFV_2					Hw2											// Vertical Scale Factor, 1/2 down scale
#define	HwCDS_SFV_4					Hw3											// Vertical Scale Factor, 1/4 down scale
#define	HwCDS_SFV_8					(Hw3|Hw2)									// Vertical Scale Factor, 1/8 down scale
#define	HwCDS_SEN_EN				Hw0											// Scale enable, 0:Disable, 1:enable

// CMOSIF Capture mode1
#define	HwCCM1_ENCNUM				0xF0000000									// Encode INT number (using CAP mode) [31:28], value area (0~15), Encode interrupt number
#define	HwCCM1_ROLNUMV				0x0F000000									// Rolling number in V (using CAP mode) [27:24], value area (0~15), Rolling number
#define	HwCCM1_ROLNUMU				0x00F00000									// Rolling number in U (using CAP mode) [23:20], value area (0~15), Rolling number
#define	HwCCM1_ROLNUMY				0x000F0000									// Rolling number in Y (using CAP mode) [19:16], value area (0~15), Rolling number
#define	HwCCM1_CB					Hw10										// Capture Busy,	0:-, 1:Capture busy
#define	HwCCM1_EIT					Hw9											// Encodig INT count,	0:Always 1 pulse, 1:Counting encoding INT
#define	HwCCM1_UES					Hw8											// Using Encoding Start Address,	0:disable, 1:Enable
#define	HwCCM1_SKIPNUM				0x000000F0									// Skip frame number (using CAP mode) [7:4], value area (0~15), Skip frame number
#define	HwCCM1_RLV					Hw3											// Rolling address V,	0:disable, 1:Enable
#define	HwCCM1_RLU					Hw2											// Rolling address U,	0:disable, 1:Enable
#define	HwCCM1_RLY					Hw1											// Rolling address Y,	0:disable, 1:Enable
#define	HwCCM1_CAP					Hw0											// Image Capture,	0:Normal, 1:Image Capture

// CMOSIF Capture mode2
#define	HwCCM2_VCNT					0x000000F0									// Description (Using CAP mode) [7:4], Threshold line counter in interrupt 1:16 line, 2:32 line, 3: 48 line...
#define	HwCCM2_VEN					Hw0											// VCNT folling enable (Using CAP mode) 0:Normal(?) DisalbeƴѰ?, 1:Enable

// CMOSIF R2Y confiquration
#define	HwCR2Y_FMT					(Hw4|Hw3|Hw2|Hw1)							// FMT[4:1]	0000 -> Input format 16bit 565RGB(RGB sequence) ڼ  750A CIF SPEC. 1-22
#define	HwCR2Y_EN					Hw0											// R2Y Enable,	0:disable, 1:Enable

// CMOSIF Current Line Count
#define	HwCCLC_LCNT					0x0000FFFF									// LCNT[15:0]	Current Line Count


/************************************************************************
*   4.4 CIF Effecter Register Define             (Base Addr = 0xB0200100) // R/W
*************************************************************************/
#define HwCEM_BASE                          		*(volatile unsigned long*)0xB0200100
#define HwCEM 										((PEFFECT)&HwCEM_BASE)

// CMOSIF Effect mode
#define	HwCEM_UVS					Hw15										// UV Swap	0:u-v-u-v sequence, 1:v-u-v-u sequence
#define	HwCEM_VB					Hw14										// V Bias (V channel value offset),	0:disable, 1:Enable 
#define	HwCEM_UB					Hw13										// U Bias (U channel value offset),	0:disable, 1:Enable
#define	HwCEM_YB					Hw12										// Y Bias (Y channel value offset),	0:disable, 1:Enable
#define	HwCEM_YCS					Hw11										// YC Swap	0:u-y-v-y sequence, 1:y-u-y-v sequence
#define	HwCEM_IVY					Hw10										// Invert Y,	0:disable, 1:Enable 
#define	HwCEM_STC					Hw9											// Strong C,	0:disable, 1:Enable 
#define	HwCEM_YCL					Hw8											// Y Clamp (Y value clipping),	0:disable, 1:Enable 
#define	HwCEM_CS					Hw7											// C Select (Color filter),	0:disable, 1:Enable(Color filter)	
#define	HwCEM_SKT					Hw6											// Sketch Enable,	0:disable, 1:Enable 
#define	HwCEM_EMM					Hw5											// Emboss mode,	0:Positive emboss, 1:Negative emboss
#define	HwCEM_EMB					Hw4											// Emboss,	0:disable, 1:Enable	
#define	HwCEM_NEGA					Hw3											// Negative mode,	0:disable, 1:Enable 
#define	HwCEM_GRAY					Hw2											// Gray mode,	0:disable, 1:Enable 
#define	HwCEM_SEPI					Hw1											// Sepia mode,	0:disable, 1:Enable	
#define	HwCEM_NOR					Hw0											// Normal mode,	0:Effect mode, 1:Normal mode 

// CMOSIF Sepia UV Setting
#define	HwHwCSUV_SEPIA_U			0x0000FF00									// SEPIA_U[15:8] U channel threshold value for sepia
#define	HwHwCSUV_SEPIA_V			0x000000FF									// SEPIA_V[7:0] V channel threshold value for sepia

// CMOSIF Color selection
#define	HwCCS_USTART				0xFF000000									// USTART [31:24]	Color filter range start point of U channel
#define	HwCCS_UEND					0x00FF0000									// UEND	[23:16]	Color filter range end point of U channel
#define	HwCCS_VSTART				0x0000FF00									// VSTART [15:8]	Color filter range start point of V channel
#define	HwCCS_VEND					0x000000FF									// VEND	[7:0]	 Color filter range end point of V channel

// CMOSIF H-filter coefficent
#define	HwCHFC_COEF0				0x00FF0000									// COEF0	[23:16] Horizontal filter coefficient0 for emboss or sketch 
#define	HwCHFC_COEF1				0x0000FF00									// COEF1	[15:8] Horizontal filter coefficient1 for emboss or sketch 
#define	HwCHFC_COEF2				0x000000FF									// COEF2	[7:0] Horizontal filter coefficient2 for emboss or sketch 

// CMOSIF Sketch threshold
#define	HwCST_THRESHOLD				0x000000FF									// Sketch [7:0] Sketch threshold

// CMOSIF Clamp threshold
#define	HwCCT_THRESHOLD				0x000000FF									// Clamp [7:0] Clamp threshold

// CMOSIF BIAS
#define	HwCBR_YBIAS					0x00FF0000									// Y_BIAS [23:16] Y value offset
#define	HwCBR_UBIAS					0x0000FF00									// U_BIAS [15:8]	U value offset
#define	HwCBR_VBIAS					0x000000FF									// V_BIAS [7:0]	V value offset

// CMOSIF Image size
#if defined (SENSOR_3M) || defined (SENSOR_5M)
#define	HwCEIS_HSIZE				0x0FFF0000									// HSIZE [26:16]	Horizontal size of input image
#else
#define	HwCEIS_HSIZE				0x07FF0000									// HSIZE [26:16]	Horizontal size of input image
#endif
#define	HwCEIS_VSIZE				0x000007FF									// VSIZE [10:0]	Vertical size of input image

#define HwCIC_H2H_WAIT 				0xFFFF0000       // H2H_WAIT [31:16]   Horizontal sync (hs)to hs wait cycle
#define HwCIC_STB_CYCLE             0x0000FF00      // STB_CYCLE [15:8]  CCIR strobe cycle,  Minimum Value of STB_CYCLE is 4.
#define HwCIC_INP_WAIT              (Hw6|Hw5|Hw4)      // INP_WAIT [6:4]     ???????????????
#define HwCIC_INPR                  Hw3     // ???????????????
#define HwCIC_FA                    Hw2     // Flush all
#define HwCIC_INE                   Hw1     // Inpath Enalbe,   0:disable, 1:Enable 
#define HwCIC_INP                   Hw0     // Inpath Mode,   0:Camera mode, 1:Memory mode

// Y 32ü  ϵ ϰ U, V  4bit ص cif address ϴ  ϴ.
//	HwCISA1_SRC_BASE Y 4Ʈ  ؼ    ,,    ׳ 32 address Ҵ Ѵ. 
// CMOSIF INPATH Source address in Y channel
#define	HwCISA1_SRC_BASE			0xF0000000									// SRC_BASE [31:28] Source base address (31 down to 28 bit assign in base address)
#define	HwCISA1_SRC_BASE_Y			0x0FFFFFFF									// SRC_BASE_Y [27:0] Source base address in Y channel (27 down to 0 bit assign in bass address)

// CMOSIF INPATH Source address in U channel
#define	HwCISA2_SRC_TYPE_422SEQ0	HwZERO										// 0: (4:2:2 SEQ0)
#define	HwCISA2_SRC_TYPE_422SEQ1	Hw28										// 1: (4:2:2 SEQ1)
#define	HwCISA2_SRC_TYPE_422SEPA	Hw29										// 2: (4:2:2 Separate)
#define	HwCISA2_SRC_TYPE_420SEPA	(Hw29|Hw28)									// 3: (4:2:0 Separate)
#define	HwCISA2_SRC_BASE_U			0x0FFFFFFF									// SRC_BASE_U [27:0] Source base address in U channal (27 down to 0 bit assign in base address)

// CMOSIF INPATH Source address in V channel
#define	HwCISA3_SRC_BASE_V			0x0FFFFFFF									// SRC_BASE_V [27:0] Source base address in V channal (27 down to 0 bit assign in base address)


// CMOSIF INPATH Source image offset
//#define	HwCISO_SRC_OFFSET_H			0x0FFF0000									// SRC_OFFSET_H [27:16] source address offset in H
//#define	HwCISO_SRC_OFFSET_V			0x00000FFF									// SRC_OFFSET_V [11:0]	source address offset in V
#define	HwCISO_SRC_OFFSET_Y			0x0FFF0000									// SRC_OFFSET_Y [27:16] source address offset in Y channel
#define	HwCISO_SRC_OFFSET_C			0x00000FFF									// SRC_OFFSET_C [11:0]	source address offset in C channel

// CMOSIF INPATH Source image size
#define	HwCISS_SRC_HSIZE			0x0FFF0000									// SRC_HSIZE [27:16] Horizontal size in source image
#define	HwCISS_SRC_VSIZE			0x00000FFF									// SRC_VSIZE [11:0]	Vertical size in source image


// CMOSIF INPATH Destination image size
#define	HwCIDS_DST_HSIZE			0x0FFF0000									// DST_HSIZE [27:16] Horizontal size in destination image
#define	HwCIDS_DST_VSIZE			0x00000FFF									// DST_VSIZE [11:0]	Vertical size in destination image

// HSCALE = SRC_HSIZE*256/DST_HSIZE
// VSCALE = SRC_VSIZE*256/DST_VSIZE
// CMOSIF INPATH Target scale
#define	HwCIS_HSCALE				0x3FFF0000									// HSCALE [29:16] Horizontal scale factor
#define	HwCIS_VSCALE				0x00003FFF									// VSCALE [13:0]	Vertical scale factor


/************************************************************************
*   4.5 CIF Scaler Register Define             (Base Addr = 0xB0200200) // R/W
*************************************************************************/
#define HwCSC_BASE                            		*(volatile unsigned long*)0xB0200200
#define HwCSC										((PCIFSCALER)&HwCSC_BASE)
// Scaler configuration
#define	HwSCC_EN					Hw0											// Scaler Enable	0:disable, 1:Enable 

// HSCALE = SRC_HSIZE*256/DST_HSIZE
// VSCALE = SRC_VSIZE*256/DST_VSIZE
// Scale factor
#define	HwSCSF_HSCALE				0x3FFF0000									// HSCALE [29:16] Horizontal scale factor
#define	HwSCSF_VSCALE				0x00003FFF									// VSCALE [13:0]	Vertical scale factor

// Image offset
#define	HwSCSO_OFFSET_H				0x0FFF0000									// H [27:16] Horizontal offset
#define	HwSCSO_OFFSET_V				0x00000FFF									// V [11:0]	Vertical offset

// Source image size
#define	HwSCSS_HSIZE				0x0FFF0000									// H [27:16] Horizontal size in source image
#define	HwSCSS_VSIZE				0x00000FFF									// V [11:0]	Vertical size in source image

// Destination image size
#define	HwSCDS_HSIZE				0x0FFF0000									// H [27:16] Horizontal size in destination image
#define	HwSCDS_VSIZE				0x00000FFF									// V [11:0]	Vertical size in destination image



/************************************************************************
*   5. ISP Register Define                          (Base Addr = 0xB0210000) // R/W
*************************************************************************/
#define HwISP_BASE                                  *(volatile unsigned long*)0xB0210000
#define HwISPIMGEFF_BASE                            *(volatile unsigned long*)0xB0210200
#define HwISPSI_BASE                                *(volatile unsigned long*)0xB0210300
#define HwISPMAIN_BASE                              *(volatile unsigned long*)0xB0210400
#define HwISPFLASH_BASE                             *(volatile unsigned long*)0xB0210660
#define HwISPSHUT_BASE                              *(volatile unsigned long*)0xB0210680
#define HwISPCPROC_BASE                             *(volatile unsigned long*)0xB0210800
#define HwISPMRSZ_BASE                              *(volatile unsigned long*)0xB0210C00
#define HwISPSRSZ_BASE                              *(volatile unsigned long*)0xB0211000
#define HwISPMI_BASE                                *(volatile unsigned long*)0xB0211400
#define HwISPJPE_BASE                               *(volatile unsigned long*)0xB0211800
#define HwISPSMIA_BASE                              *(volatile unsigned long*)0xB0211A00
#define HwISPMIPI_BASE                              *(volatile unsigned long*)0xB0211C00
#define HwISPAFM_BASE                               *(volatile unsigned long*)0xB0212000
#define HwISPBP_BASE                                *(volatile unsigned long*)0xB0212100
#define HwISPLSC_BASE                               *(volatile unsigned long*)0xB0212200
#define HwISPIS_BASE                                *(volatile unsigned long*)0xB0212300
#define HwISPHIST_BASE                              *(volatile unsigned long*)0xB0212400
#define HwISPFILT_BASE                              *(volatile unsigned long*)0xB0212500
#define HwISPCAC_BASE                               *(volatile unsigned long*)0xB0212580
#define HwISPAE_BASE                                *(volatile unsigned long*)0xB0212600
#define HwISPBLS_BASE                               *(volatile unsigned long*)0xB0212700
#define HwISPDPF_BASE                               *(volatile unsigned long*)0xB0212800
#define HwISPDPCC_BASE                              *(volatile unsigned long*)0xB0212900
#define HwISPWDR_BASE                               *(volatile unsigned long*)0xB0212A00



/*************************************************************************
*   6. Camera Bus Configuration Register Define     (Base Addr = 0xB0230000) // R/W
*************************************************************************/
#define HwCAMBUSCFG_BASE                            *(volatile unsigned long*)0xB0230000
#define HwCAMBUSCFG									((PCAMBUSCFG)&HwCAMBUSCFG_BASE)

//    volatile unsigned int   PowerDownMode;              // 0xB0230000
// AHB HCLKs, supplied to each block, are controlled  by clock enable signal
#define	HwCAMBUS_MHCLK_ISP			Hw1										// case ISP, MASK Enable signals of HCLK clock gating logic, 0 : enable clock,  1: disable clock
#define	HwCAMBUS_MHCLK_CIF			Hw0										// case CIF, MASK Enable signals of HCLK clock gating logic, 0 : enable clock,  1: disable clock

//    volatile unsigned int   SoftResetRegister;            // 0xB0230004
// AHB SWRESETs, supplied to each block, are controlled  by SWRESET enable signal
#define	HwCAMBUS_SWRESET_ISP		Hw1									// case ISP, Enable signals of HCLK clock gating logic, 0 : disable SWRESET,  1: enable SWRESET
#define	HwCAMBUS_SWRESET_CIF		Hw0									// case CIF, Enable signals of HCLK clock gating logic, 0 : disable SWRESET,  1: enable SWRESET

//   volatile unsigned int   CAMBusClk0Sel;                 // 0xB0230008
#define	HwCAMBUS_CLKO_SEL			Hw0									// Camera Module Clock Selection, 0 : CIF_ICLK,  1: ISP CCLK

//    volatile unsigned int   MemoryEMACtrReg;           // 0xB023000C
//Extra Margin Adjustment pins provide the option of adding delays into internal timing pulses of memory
#define	HwCAMBUS_MEM_EMA			Hw2|Hw1|Hw0						// 001 (default)

//	volatile unsigned int   ISP_RC_CTRL;                    // 0xB0230020
#define	HwCAMBUS_RC_ISP				Hw0						//  ISP_read cache enable

//    volatile unsigned int   ISP_RC_A0MIN;                 // 0xB0230024
#define	HwCAMBUS_SA_ISP				0xFFFFFFFF						//  Start address of ISP prefetch address

//    volatile unsigned int   ISP_RC_A0MAX;                  // 0xB0230028
#define	HwCAMBUS_EA_ISP				0xFFFFFFFF						//  End address of ISP prefetch address

//    volatile unsigned int   CIF_RC_CTRL;                    // 0xB023002C
#define	HwCAMBUS_RC_CIF				Hw0						//  CIF_read cache enable 

//    volatile unsigned int   CIF_RC_A0MIN;                 // 0xB0230030
#define	HwCAMBUS_SA_CIF				0xFFFFFFFF						//  Start address of ISP prefetch address

//    volatile unsigned int   CIF_RC_A0MAX;                 // 0xB0230034
#define	HwCAMBUS_EA_CIF				0xFFFFFFFF						//  Start address of ISP prefetch address




/*******************************************************************************
*    TCC9300 DataSheet PART 10 DISPLAY Sub Bus
********************************************************************************/
/*************************************************************************
*   4, 5. MIPI Register Define                      (Base Addr = 0xB0230000) // R/W
*************************************************************************/
#define HwMIPI_BASE                                 *(volatile unsigned long*)0xB0B10000
#define HwMIPIDSBUSCFG_BASE                         *(volatile unsigned long*)0xB0B11000



#endif
