/* 
 * linux/drivers/char/tcc_dxb/ctrl/tcc_dxb_control.c
 *
 * Author:  <linux@telechips.com>
 * Created: 10th Jun, 2008 
 * Description: Telechips Linux BACK-LIGHT DRIVER
 *
 * Copyright (c) Telechips, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/moduleparam.h>
#include <linux/device.h>
#include <linux/fs.h>
#include <linux/errno.h>
#include <asm/uaccess.h>
#include <bsp.h>
#include <asm/io.h>
#include <asm/mach-types.h>
#include <linux/delay.h>
#include "tcc_dxb_control.h"

static volatile PGPIO  RGPIO;
static unsigned int guiBoardType = BOARD_TDMB_TCC3150;;

static void tcc_dxb_ctrl_power_off(void)
{
#if 0	
    if(machine_is_tcc8900())
    {
    }
    if(machine_is_tcc9200s()) 
    {
    }
#endif   
#if defined(CONFIG_MACH_TCC9200) || defined(CONFIG_MACH_TCC9201) || defined(CONFIG_MACH_TCC8900) || defined(CONFIG_MACH_TCC9300CM)
    if(guiBoardType == BOARD_DVBT_DIB9090 || BOARD_DVBT_DIB9090 == BOARD_DVBT_DIB7070)
    {
	    if(guiBoardType == BOARD_DVBT_DIB9090 )
		{
			/*Power
			*/
			BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //DXB1_PWDN Power up
			BITSET(RGPIO->GPEEN, Hw3);
			BITCLR(RGPIO->GPEDAT, Hw3);		
		}
		else
		{
			/*Power
			*/
			BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //DXB1_PWDN Power up
			BITSET(RGPIO->GPEEN, Hw3);
			BITSET(RGPIO->GPEDAT, Hw3);
		}

		/*Reset
		*/
		BITCLR(RGPIO->GPEFN1, Hw16-Hw12);
		BITSET(RGPIO->GPEEN , Hw11);
		BITCLR(RGPIO->GPEDAT, Hw11);
    }
	else if(guiBoardType == BOARD_TDMB_TCC3150 )		
	{
		BITCLR(RGPIO->GPEDAT, Hw3);
		BITCLR(RGPIO->GPEDAT, Hw11);
	}	
	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPEFN0, Hw16 - Hw12);        
        BITSET (RGPIO->GPEEN,  Hw3);  //DXB1_PD Set GPIO Output mode
        BITCLR (RGPIO->GPEDAT, Hw3);  //DXB1_PD Clear
        BITCLR (RGPIO->GPEDAT, Hw11); //DXB1_RST# Clear

	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
		/*Power
		*/
		BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //GPIO_E3 set GPIO for DXB1_PD
		BITSET(RGPIO->GPEEN, Hw3);
		BITCLR(RGPIO->GPEDAT, Hw3);

		BITCLR(RGPIO->GPDFN1, Hw20-Hw16);  //GPIO_D12 set GPIO for DXB0_PD
		BITSET(RGPIO->GPDEN, Hw12);
		BITCLR(RGPIO->GPDDAT, Hw12);
		
	}	
	else if(guiBoardType == BOARD_DVBT_DIB9090M_PA)
    {
		//Control DEEPPWDN
		//Control DEEPPWDN this is only for tcc9300cm
		BITCLR(RGPIO->GPEFN2, Hw32-Hw28);
		BITSET(RGPIO->GPEEN , Hw23);
		BITCLR(RGPIO->GPEDAT, Hw23);

    }
#elif defined(CONGIF_MACH_TCC9200S) 	
	if(guiBoardType == BOARD_TDMB_TCC3150 )		
	{
		BITCLR(RGPIO->GPEDAT, Hw3);
		BITCLR(RGPIO->GPEDAT, Hw11);
	}
	else if(guiBoardType == BOARD_TDMB_TCC3150 )		
	{
		BITCLR(RGPIO->GPEDAT, Hw5);
		BITCLR(RGPIO->GPDDAT, Hw8);
	}	
#elif defined(CONFIG_MACH_TCC9300)
	if(guiBoardType == BOARD_DVBT_DIB9090)
    {
		/*Reset
		*/
		BITCLR(RGPIO->GPGFN1, Hw12-Hw8);
		BITSET(RGPIO->GPGEN , Hw10);
		BITCLR(RGPIO->GPGDAT, Hw10);
	}	
	else if(guiBoardType == BOARD_TDMB_TCC3150 )
	{
		BITCLR(RGPIO->GPGDAT, Hw10);
	}
	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161 )	
	{
		BITCLR (RGPIO->GPGFN1, Hw12-Hw8); //DXB1_RST# Set GPIO mode
        BITSET (RGPIO->GPGEN,  Hw10); //DXB1_RST# Set GPIO Output mode
        BITCLR (RGPIO->GPGDAT, Hw10); //DXB1_RST# Clear
	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
		/*Reset
		*/
		BITCLR(RGPIO->GPGFN1, Hw12-Hw8);
		BITSET(RGPIO->GPGEN, Hw10);
		BITCLR(RGPIO->GPGDAT, Hw10);
	}	
#elif defined(CONFIG_MACH_TCC9300ST)	
	if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPFFN0, Hw28-Hw24); //TSIF_ON Enable(I/O Power)	
		BITCLR (RGPIO->GPFFN1, Hw20-Hw16); //TCC3511_PWDN		
		BITCLR (RGPIO->GPEEN,  Hw12); //TCC3511_PWDN Set Output Mode
		BITCLR (RGPIO->GPEEN,  Hw6);  //TSIF_ON Set Output Mode
	}
#endif

}

static void tcc_dxb_ctrl_power_on(void)
{
#if defined(CONFIG_MACH_TCC9200) || defined(CONFIG_MACH_TCC9201) || defined(CONFIG_MACH_TCC8900) || defined(CONFIG_MACH_TCC9300CM)
    if(guiBoardType == BOARD_DVBT_DIB9090 || BOARD_DVBT_DIB9090 == BOARD_DVBT_DIB7070)
    {
	    /*Reset
		*/
		BITCLR(RGPIO->GPEFN1, Hw16-Hw12);
		BITSET(RGPIO->GPEEN , Hw11);
		BITSET(RGPIO->GPEDAT, Hw11);
			
		if(guiBoardType == BOARD_DVBT_DIB9090)
		{
			/*Power
			*/
			BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //DXB1_PWDN Power up
			BITSET(RGPIO->GPEEN, Hw3);
			BITSET(RGPIO->GPEDAT, Hw3);

			/*RF Control
			*/
			BITCLR(RGPIO->GPDFN1, Hw20-Hw16);
			BITSET(RGPIO->GPDEN, Hw12);
			BITSET(RGPIO->GPDDAT, Hw12);
		}
		else
		{ 
			/*Power
			*/
			BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //DXB1_PWDN Power up
			BITSET(RGPIO->GPEEN, Hw3);
			BITCLR(RGPIO->GPEDAT, Hw3);
		}
    }
	else if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		BITSET(RGPIO->GPEDAT, Hw3);
	}
	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{

		BITCLR (RGPIO->GPEFN0, Hw16 - Hw12); //DXB1_PD Set GPIO mode
        BITCLR (RGPIO->GPEFN1, Hw16 - Hw12); //DXB1_RST# Set GPIO mode
        
        BITSET (RGPIO->GPEEN,  Hw3);  //DXB1_PD Set GPIO Output mode
        BITCLR (RGPIO->GPEDAT, Hw11); //DXB1_RST# Clear
        BITCLR (RGPIO->GPEDAT, Hw3);  //DXB1_PD Clear
        msleep (20);
        BITSET (RGPIO->GPEDAT, Hw3);  //DXB1_PD Set
        msleep (20);
        
        // reset
        BITSET (RGPIO->GPEEN,  Hw11); //DXB1_RST# Set GPIO Output mode
        BITCLR (RGPIO->GPEDAT, Hw11); //DXB1_RST# Clear
        msleep (20);
        BITSET (RGPIO->GPEDAT, Hw11); //DXB1_RST# Set

	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
		/*Reset
		*/
		BITCLR(RGPIO->GPEFN1, Hw16-Hw12);
		BITSET(RGPIO->GPEEN, Hw11);
		BITSET(RGPIO->GPEDAT, Hw11);

		BITCLR(RGPIO->GPEFN0, Hw16-Hw12); //GPIO_E3 set GPIO for DXB1_PD
		BITSET(RGPIO->GPEEN , Hw3);
		BITSET(RGPIO->GPEDAT, Hw3);

		BITCLR(RGPIO->GPDFN1, Hw20-Hw16);  //GPIO_D12 set GPIO for DXB0_PD
		BITSET(RGPIO->GPDEN , Hw12);
		BITSET(RGPIO->GPDDAT, Hw12);
 
	}	
	else if(guiBoardType == BOARD_DVBT_DIB9090M_PA)
    {
		//Control DEEPPWDN this is only for tcc9300cm
		BITCLR(RGPIO->GPEFN2, Hw32-Hw28);
		BITSET(RGPIO->GPEEN , Hw23);
		BITSET(RGPIO->GPEDAT, Hw23);
    }
#elif defined(CONGIF_MACH_TCC9200S) 	
	if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		BITSET(RGPIO->GPEDAT, Hw5);
	}	
#elif defined(CONFIG_MACH_TCC9300) 
	if(guiBoardType == BOARD_DVBT_DIB9090)
    {
		/*Clear DXB1_IRQ
	    */
		BITCLR(RGPIO->GPGFN1, Hw20-Hw16);
		BITSET(RGPIO->GPGEN, Hw12);
		BITCLR(RGPIO->GPGDAT, Hw12);
		
		/*Reset
		*/
		BITCLR(RGPIO->GPGFN1, Hw12-Hw8);
		BITSET(RGPIO->GPGEN , Hw10);
		BITCLR(RGPIO->GPGDAT, Hw10);

		/*RF Control //don't support 7070
		*/
		BITCLR(RGPIO->GPCFN3, Hw20-Hw16);
		BITSET(RGPIO->GPCEN, Hw28);
		BITSET(RGPIO->GPCDAT, Hw28);
	}	
	else if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		//don't need control
	}
 	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPGFN1, Hw12-Hw8); //DXB1_RST# Set GPIO mode
        
        //reset
        BITSET (RGPIO->GPGEN,  Hw10); //DXB1_RST# Set GPIO Output mode
        BITCLR (RGPIO->GPGDAT, Hw10); //DXB1_RST# Clar
        msleep (20);
        BITSET (RGPIO->GPGDAT, Hw10); //DXB1_RST# Set
	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
 		/*Clear DXB1_IRQ
		*/
		BITCLR(RGPIO->GPGFN1, Hw20-Hw16);
		BITSET(RGPIO->GPGEN, Hw12);
		BITCLR(RGPIO->GPGDAT, Hw12);

		/*Reset
		*/
		BITCLR(RGPIO->GPGFN1, Hw12-Hw8);
		BITSET(RGPIO->GPGEN , Hw10);
		BITSET(RGPIO->GPGDAT, Hw10);
	}
#elif defined(CONFIG_MACH_TCC9300ST)		
	if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPFFN0, Hw28-Hw24); //TSIF_ON Enable(I/O Power)	
		BITCLR (RGPIO->GPEFN1, Hw20-Hw16); //TCC3511_PWDN
		BITCLR (RGPIO->GPEFN1, Hw24-Hw20); //TCC3511_RESET

		BITSET (RGPIO->GPFEN,  Hw6);  //TSIF_ON Set Output Mode
		BITSET (RGPIO->GPEEN,  Hw12); //TCC3511_PWDN Set Output Mode
		BITSET (RGPIO->GPEEN,  Hw13); //TCC3511_RESET Set Output Mode

		BITSET (RGPIO->GPFDAT,  Hw6); //Power on :: TSIF_ON 
		BITSET (RGPIO->GPEDAT,  Hw12); //TCC3511_PWDN

		BITCLR (RGPIO->GPEDAT,  Hw13); //Reset :: TCC3511_RESET
		msleep (20);
		BITSET (RGPIO->GPEDAT,  Hw13);		
	}
#endif

}
static void tcc_dxb_ctrl_power_reset(void)
{
#if defined(CONFIG_MACH_TCC9200) || defined(CONFIG_MACH_TCC9201) || defined(CONFIG_MACH_TCC8900) || defined(CONFIG_MACH_TCC9300CM)
    if(guiBoardType == BOARD_DVBT_DIB9090 || BOARD_DVBT_DIB9090 == BOARD_DVBT_DIB7070)
    {
		BITCLR(RGPIO->GPEDAT, Hw11);
		msleep(100);		
		BITSET(RGPIO->GPEDAT, Hw11);
		msleep(100);		
	}	
	else if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		BITCLR(RGPIO->GPEDAT, Hw11);
		msleep(100);		
		BITSET(RGPIO->GPEDAT, Hw11);
		msleep(100);		
	}
 	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPEFN1, Hw16 - Hw12); //DXB1_RST# Set GPIO mode        
        BITSET (RGPIO->GPEEN,  Hw11); //DXB1_RST# Set GPIO Output mode
        BITCLR (RGPIO->GPEDAT, Hw11); //DXB1_RST# Clear 
        msleep (20);
        BITSET (RGPIO->GPEDAT, Hw11); //DXB1_RST# Set
	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
		BITCLR(RGPIO->GPEDAT, Hw11);
		msleep (20);
		BITSET(RGPIO->GPEDAT, Hw11);
		msleep (20);
	}	
	else if(guiBoardType == BOARD_DVBT_DIB9090M_PA)
    {
		//Control TOTALPWDN
    }
#elif defined(CONGIF_MACH_TCC9200S) 	
	if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		BITCLR(RGPIO->GPDDAT, Hw8);
		msleep(100);		
		BITSET(RGPIO->GPDDAT, Hw8);
		msleep(100);		
	}
#elif defined(CONFIG_MACH_TCC9300) 
	if(guiBoardType == BOARD_DVBT_DIB9090)
    {
		BITCLR(RGPIO->GPGDAT, Hw10);
		msleep(100);		
		BITSET(RGPIO->GPGDAT, Hw10);
		msleep(100);
	}	
	else if(guiBoardType == BOARD_TDMB_TCC3150 )	
	{
		BITCLR(RGPIO->GPGDAT, Hw10);
		msleep(100);		
		BITSET(RGPIO->GPGDAT, Hw10);	
		msleep(100);		
	}
 	else if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPGFN1, Hw12-Hw8); //DXB1_RST# Set GPIO mode
        BITSET (RGPIO->GPGEN,  Hw10); //DXB1_RST# Set GPIO Output mode
        BITCLR (RGPIO->GPGDAT, Hw10); //DXB1_RST# Clar
        msleep (20);
        BITSET (RGPIO->GPGDAT, Hw10); //DXB1_RST# Set
	}
	else if(guiBoardType == BOARD_ISDBT_DIB10096 )	
	{
		BITCLR(RGPIO->GPGDAT, Hw10);
		msleep(100);		
		BITSET(RGPIO->GPGDAT, Hw10);
		msleep(100);
	}	
#elif defined(CONFIG_MACH_TCC9300ST)	
	if(guiBoardType == BOARD_DXB_TCC3510 || guiBoardType == BOARD_TDMB_TCC3161)	
	{
		BITCLR (RGPIO->GPEFN1, Hw24-Hw20); //TCC3511_RESET
		BITCLR (RGPIO->GPEDAT,  Hw13); //Reset :: TCC3511_RESET
		msleep (20);
		BITSET (RGPIO->GPEDAT,  Hw13);		
	}
#endif

}
static void tcc_dxb_ctrl_set_board(unsigned int uiboardtype)
{
	guiBoardType = uiboardtype;
#if defined(CONFIG_MACH_TCC9200) || defined(CONFIG_MACH_TCC9201) || defined(CONFIG_MACH_TCC8900) || defined(CONFIG_MACH_TCC9300CM)
	if(guiBoardType == BOARD_TDMB_TCC3150)
    {
		// External interrupt
		BITCLR(RGPIO->GPAFN1, (Hw16 - Hw12)); // use to GPIO
		BITCLR(RGPIO->GPAEN, Hw11);

		// PD
		BITCLR(RGPIO->GPEFN0, (Hw16 - Hw12)); // use to GPIO
		BITSET(RGPIO->GPEEN, Hw3);
		BITCLR(RGPIO->GPEDAT, Hw3);

		// RST
		BITCLR(RGPIO->GPEFN1, (Hw16 - Hw12)); // use to GPIO	
		BITSET(RGPIO->GPEEN, Hw11);
		BITCLR(RGPIO->GPEDAT, Hw11);
	}
#elif defined (CONGIF_MACH_TCC9200S) 
	if(guiBoardType == BOARD_TDMB_TCC3150)
    {
		// External interrupt
		BITCLR(RGPIO->GPAFN1, (Hw16 - Hw12)); // use to GPIO
		BITCLR(RGPIO->GPAEN, Hw11);
		
		// PD
		BITCLR(RGPIO->GPEFN0, (Hw24 - Hw20)); // use to GPIO
		BITSET(RGPIO->GPEEN, Hw5);
		BITCLR(RGPIO->GPEDAT, Hw5);

		// RST
		BITCLR(RGPIO->GPDFN1, (Hw4 - Hw0)); // use to GPIO	
		BITSET(RGPIO->GPDEN, Hw8);
		BITCLR(RGPIO->GPDDAT, Hw8);
	}
#elif defined(CONFIG_MACH_TCC9300) 
	if(guiBoardType == BOARD_TDMB_TCC3150)
    {
		// External interrupt
		BITCLR(RGPIO->GPGFN1, (Hw20 - Hw16)); // use to GPIO
		BITCLR(RGPIO->GPGEN, Hw12);
		
		// RST
		BITCLR(RGPIO->GPGFN1, (Hw12 - Hw8)); // use to GPIO
		BITSET(RGPIO->GPGEN, Hw10);
		BITCLR(RGPIO->GPGDAT, Hw10);		
	}
#elif defined(CONFIG_MACH_TCC9300ST)			
#endif
}

static void tcc_dxb_ctrl_get_info(ST_CTRLINFO_ARG *pstCtrlInfo)
{
#if defined(CONGIF_MACH_TCC9200S) || defined(CONFIG_MACH_TCC9200) || defined(CONFIG_MACH_TCC9201) || defined(CONFIG_MACH_TCC8900) || defined(CONFIG_MACH_TCC9300CM)
	if(guiBoardType == BOARD_DVBT_DIB9090M_PA)
		pstCtrlInfo->uiI2C = 4; //this is only for tcc9300cm
	else	
		pstCtrlInfo->uiI2C = 1;
#elif defined(CONFIG_MACH_TCC9300) || defined(CONFIG_MACH_TCC9300ST)
	pstCtrlInfo->uiI2C = 4;
#endif
}

static int tcc_dxb_ctrl_ioctl(struct inode *inode, struct file *filp, 
							unsigned int cmd, unsigned long arg)
{
    unsigned int uiboardtype;	
	ST_CTRLINFO_ARG stCtrlInfo;
    //printk(KERN_INFO "%s  (0x%x)  \n", __FUNCTION__, cmd);
	switch (cmd) {
		case IOCTL_DXB_CTRL_OFF:
		    tcc_dxb_ctrl_power_off();
			break;
		case IOCTL_DXB_CTRL_ON:
		    tcc_dxb_ctrl_power_on();
			break;

		case IOCTL_DXB_CTRL_RESET:
		    tcc_dxb_ctrl_power_reset();
			break;

		case IOCTL_DXB_CTRL_SET_BOARD:
            copy_from_user((void *)&uiboardtype, (const void *)arg, sizeof(unsigned long));			
            if(uiboardtype < BOARD_MAX)
            {
                tcc_dxb_ctrl_set_board(uiboardtype);
				printk(KERN_INFO "%s  (0x%x) :: %d \n", __FUNCTION__, cmd, uiboardtype);
            }	
			break;
		case IOCTL_DXB_CTRL_GET_CTLINFO:
			tcc_dxb_ctrl_get_info(&stCtrlInfo);
			printk(KERN_INFO "%s  (0x%x) :: I2C(%d)SPI(%d) \n", __FUNCTION__, cmd, stCtrlInfo.uiI2C, stCtrlInfo.uiSPI);
			copy_to_user((ST_CTRLINFO_ARG *)arg, &stCtrlInfo, sizeof(ST_CTRLINFO_ARG));
			break;
		default:
			printk("bl: unrecognized ioctl (0x%x)\n", cmd); 
			return -EINVAL;
			break;
	}

	return 0;
}

static int tcc_dxb_ctrl_release(struct inode *inode, struct file *filp)
{
	return 0;
}

static int tcc_dxb_ctrl_open(struct inode *inode, struct file *filp)
{
    RGPIO = (PGPIO)tcc_p2v(HwGPIO_BASE);	
	return 0;
}

struct file_operations tcc_dxb_ctrl_fops =
{
	.owner		= THIS_MODULE,
	.open		= tcc_dxb_ctrl_open,
	.release	= tcc_dxb_ctrl_release,
	.ioctl		= tcc_dxb_ctrl_ioctl,
};

static struct class *tcc_dxb_ctrl_class;

static int __init tcc_dxb_ctrl_init(void)
{
	int res;

	res = register_chrdev(DXB_CTRL_DEV_MAJOR, DXB_CTRL_DEV_NAME, &tcc_dxb_ctrl_fops);
	if (res < 0)
		return res;
	tcc_dxb_ctrl_class = class_create(THIS_MODULE, DXB_CTRL_DEV_NAME);
	device_create(tcc_dxb_ctrl_class, NULL, MKDEV(DXB_CTRL_DEV_MAJOR, DXB_CTRL_DEV_MINOR), NULL, DXB_CTRL_DEV_NAME);

    printk(KERN_INFO "%s\n", __FUNCTION__);
	return 0;
}

static void __exit tcc_dxb_ctrl_exit(void)
{
	device_destroy(tcc_dxb_ctrl_class, MKDEV(DXB_CTRL_DEV_MAJOR, DXB_CTRL_DEV_MINOR));
    class_destroy(tcc_dxb_ctrl_class);
	unregister_chrdev(DXB_CTRL_DEV_MAJOR, DXB_CTRL_DEV_NAME);
    printk(KERN_INFO "%s\n", __FUNCTION__);
}

module_init(tcc_dxb_ctrl_init);
module_exit(tcc_dxb_ctrl_exit);

MODULE_AUTHOR("Telechips Inc.");
MODULE_DESCRIPTION("TCC Broadcasting Control(Power, Reset..)");
MODULE_LICENSE("GPL");

