/****************************************************************************
 *   FileName    : tca_i2c.h
 *   Description : 
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/
#ifndef __TCA_I2C_H__
#define __TCA_I2C_H__

/* Define
 */
#define I2C_NUM_OF_CH		4
#define GPA_BASE 			0xF0102000
#define I2C_IRQSTR_OFFSET	0xC0	/* only I2C */
#define I2C_ICLK_OFFSET		0x80	/* only SMU_I2C */


/* register structure
 */
#pragma pack(push, 4)
struct tcc_gpio {
	volatile unsigned long DAT, EN, SET, CLR, XOR, CD0, CD1, PD0, PD1, FN0, FN1, FN2, FN3;
};

struct tcc_i2c_regs {
	volatile unsigned long PRES, CTRL, TXR, CMD, RXR, SR, TR;
};
#pragma pack(pop)


/* extern functions
 */
extern void tca_i2c_reset(void);
extern void tca_i2c_setgpio(int ch);
extern void tca_i2c_setclock(int ch, volatile struct tcc_i2c_regs *i2c_reg, unsigned int i2c_clock);

#endif	//__TCA_I2C_H__

