

/****************************************************************************
 *   FileName    : tca_keypad.h
 *   Description : 
 ****************************************************************************
*
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
*
 ****************************************************************************/
#ifndef __TCA_KEYPAD_H__
#define __TCA_KEYPAD_H__


#ifdef __cplusplus
extern "C" {
#endif


#ifdef __KERNEL__
#include <linux/input.h>
#	if defined(_TCC79x_)
#		include <mach/tcc79x.h>
#	elif defined(_TCC83x_)
#		include <mach/tcc83x_virt.h>
#	endif
#else
#	if defined(_TCC79x_)
#		include "TCC79x_Virtual.h"
#	elif defined(_TCC83x_)
#		include "TCC83x_Virtual.h"
#	endif
#endif

#if defined(CONFIG_ARCH_TCC92X) || defined(CONFIG_ARCH_TCC93XX)
#include <asm/io.h>
#include <mach/bsp.h>
#include <mach/tca_ckc.h>
#endif

/*****************************************************************************
*
* Defines
*
******************************************************************************/

/*****************************************************************************
*
* Enum
*
******************************************************************************/

/*****************************************************************************
*
* Type Defines
*
******************************************************************************/

/*****************************************************************************
*
* Structures
*
******************************************************************************/

/*****************************************************************************
*
* External Variables
*
******************************************************************************/

/*****************************************************************************
*
* External Functions
*
******************************************************************************/
unsigned int	tca_keypad_getscancode(void);
int 			tca_keypad_getkeycodebyscancode(unsigned int adcdata);
void			tca_keypad_adccontrollerinit(void);
void 			tca_keypad_adcpowerup(void);
void			tca_keypad_adcpowerdown(void);

#ifdef __cplusplus
 } 
#endif

#endif	//__TCA_KEYPAD_H__

