/*
 * drivers/media/video/tcc83xx/mt9d112_2mp.h
 *
 * Register definitions for the mt9d111 CameraChip.
 *
 * Author: zzau (zzau@telechips.com)
 *
 * Copyright (C) 2008 Telechips, Inc.
 *
 * This file is licensed under the terms of the GNU General Public License 
 * version 2. This program is licensed "as is" without any warranty of any 
 * kind, whether express or implied.
 */
#include <mach/globals.h>
#include "sensor_if.h"

#ifndef MT9D112_H
#define MT9D112_H

/* The MT9D112 I2C sensor chip has a fixed slave address of 0x7A. */
#define SENSOR_I2C_ADDR		0x7A

#define REG_TERM 0x0000	/* terminating list entry for reg */
#define VAL_TERM 0x0000	/* terminating list entry for val */

//CLOCK
#if defined(CONFIG_ARCH_TCC93XX)
#if defined(CONFIG_USE_ISP)
#define CKC_CAMERA_MCLK				240000		//(1-e)96M-25.8fps,  (2-o)86.4M - 23.26fps,  (3-e)82.5M - 22.2fps, (1-o)76.8M-20.6fps, 64Mhz-17fps
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1
#define CKC_CAMERA_SCLK				1080000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL2
#else
#define CKC_CAMERA_MCLK				240000
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1
#define CKC_CAMERA_SCLK				810000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL2
#endif
#elif defined(CONFIG_ARCH_TCC92X)
#define CKC_CAMERA_MCLK				240000
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1
#define CKC_CAMERA_SCLK				800000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL2
#endif

#define FRAMESKIP_COUNT_FOR_CAPTURE 1

// ZOOM Setting!!
#define PRV_W			800
#define PRV_H			600
#define PRV_ZOFFX		8
#define PRV_ZOFFY		6

#define CAP_W			1600
#define CAP_H			1200
#define CAP_ZOFFX		16
#define CAP_ZOFFY		12

#define CAM_2XMAX_ZOOM_STEP 	25
#define CAM_CAPCHG_WIDTH  		800

#ifdef CONFIG_USE_ISP
#define CAM_MAX_ZOOM_STEP    25+1
#endif

struct sensor_reg {
	unsigned short reg;
	unsigned short val;
};

struct capture_size {
	unsigned long width;
	unsigned long height;
};

extern struct capture_size sensor_sizes[];
extern void sensor_init_fnc(SENSOR_FUNC_TYPE *sensor_func);

#endif /* MT9D112_H */

