/*
 * drivers/media/video/tcccam/mt9p111_5mp.h
 *
 * Register definitions for the mv9317 CameraChip.
 *
 * Author: zzau (zzau@telechips.com)
 *
 * Copyright (C) 2008 Telechips, Inc.
 *
 * This file is licensed under the terms of the GNU General Public License 
 * version 2. This program is licensed "as is" without any warranty of any 
 * kind, whether express or implied.
 */
#include <mach/globals.h>
#include "sensor_if.h"

#ifndef MT9P111_H
#define MT9P111_H

/* The MV9317 I2C sensor chip has a fixed slave address of 0x5D. */
#define SENSOR_I2C_ADDR		0x78

#define REG_TERM 0x0000	/* terminating list entry for reg */
#define VAL_TERM 0x0000	/* terminating list entry for val */
#define VAL_END 0x1111	/* ending entry for val-list */

//CLOCK
#if defined(CONFIG_ARCH_TCC93XX)
#define CKC_CAMERA_MCLK				160000
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1
#define CKC_CAMERA_SCLK				640000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL1
#elif defined(CONFIG_ARCH_TCC92X)
#define CKC_CAMERA_MCLK				160000
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1 	// DIRECTPLL2
#define CKC_CAMERA_SCLK				1080000 	// 1330000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL2
#endif

#define FRAMESKIP_COUNT_FOR_CAPTURE 1

// ZOOM Setting!!
#define PRV_W			1280
#define PRV_H			720
#define PRV_ZOFFX		8
#define PRV_ZOFFY		6

#define CAP_W			2560
#define CAP_H			1920
#define CAP_ZOFFX		16
#define CAP_ZOFFY		12

#define CAM_2XMAX_ZOOM_STEP 	31
#define CAM_CAPCHG_WIDTH  		1024


struct sensor_reg {
	unsigned short reg;
	unsigned short val[20];
};

struct capture_size {
	unsigned long width;
	unsigned long height;
};

extern struct capture_size sensor_sizes[];
extern void sensor_init_fnc(SENSOR_FUNC_TYPE *sensor_func);

#endif /* MT9P111_H */

